<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
------------------------------------------------------------------ --->

<cfinclude template="udf/udf_cookieFunctions.cfm">
<cfinclude template="udf/udf_verifyIP.cfm">
<cfinclude template="udf/udf_formatSize.cfm">

	<!--- check ipmasking restrictions --->
	<cfset dbxr.ipOK = false>
	<cfif listlen(dbx.ipmasks)>
		<cfloop list="#dbx.ipmasks#" index="dbxr.i">
			<cfif not verifyIP(cgi.remote_addr,trim(dbxr.i))>
				<cfset dbxr.ipOK = false>
			</cfif>
		</cfloop>
	<cfelse>
		<cfset dbxr.ipOK = true>
	</cfif>
	
	<cfif not dbxr.ipOK>
		<cfoutput>
		<div style="width: 100%; height: 100%; text-align: center; vertical-align: middle;">
		You have attempted to access DBX from a non authorized location. Contact your system administrator.
		</div>
		</cfoutput>
		<cfabort>
	</cfif>
	
	<!--- create a fully resolved prefix to address cross-site scripting anomalies when using hosts file + multi-ip servers (reported issue) --->
	<cfset dbxr.fullpathprefix = lcase(listfirst(cgi.server_protocol,"/")) & "://" & cgi.server_name & iif(cgi.server_port neq 80,de(":#cgi.server_port#"),de("")) & getdirectoryfrompath(cgi.script_name)><!--- js/css, etc --->
	<cfset dbxr.fullfilepathprefix = lcase(listfirst(cgi.server_protocol,"/")) & "://" & cgi.server_name & iif(cgi.server_port neq 80,de(":#cgi.server_port#"),de("")) & cgi.script_name><!--- frames --->
	
	<!--- initialize cookies --->
	<cfif not isdefined("cookie.DBXLOGIN")>
		<cfset setCookie("dbxlogin","0",dbx.enckey,"SESSION")>
	</cfif>
	<cfif not isdefined("cookie.DBXDSN")>
		<cfset setCookie("dbxdsn","0",dbx.enckey,"SESSION")>
	</cfif>
	<cfif not isdefined("cookie.DBXPERSISTDSN")>
		<cfset setCookie("dbxpersistdsn","0",dbx.enckey)>
	</cfif>
	<cfif not isdefined("cookie.DBXCODEGENDSN")>
		<cfset setCookie("dbxcodegendsn","0",dbx.enckey)>
	</cfif>
	<cfif not isdefined("cookie.DBXPREFS")>
		<cfset setCookie("dbxprefs","qry%method%",dbx.enckey)>
	</cfif>
	
	
	<!--- logging out  --->
	<cfif isdefined("url.lo")>
		<cfset setCookie("dbxlogin","0",dbx.enckey,"SESSION")>
		<cfset setCookie("dbxdsn","0",dbx.enckey,"SESSION")>
		<cfset dbxr.jsFocus = "login">
		<cfset dbxr.loggedin = false>
	</cfif>
	
	<!--- switching datasources --->
	<cfif isdefined("url.sw")>
		<cfset setCookie("dbxdsn","0",dbx.enckey,"SESSION")>
		<cfset dbxr.jsFocus = "dbdsn">
	</cfif>
	
	<cfset dbxr.message = "">
	<cfset dbxr.loginmessage = "">
		
	<cfheader name="pragma" value="no-cache">
	<cfif not len(dbx.loginpass)>
		<cfset setCookie("dbxlogin","loggedin",dbx.enckey,"SESSION")>
		<cfset dbxr.loggedin = true>
		<cfset dbxr.dodsn = 1>
		
	<cfelseif len(dbx.loginpass) and not getCookie("dbxlogin",dbx.enckey) eq "loggedin">
	
		<cfif isdefined("form.login")>
			<!--- <cfif (not isdefined("cookie.dbxlogin") or getCookie("dbxlogin",dbx.enckey) neq "loggedin")> --->
				<cfif form.login eq dbx.loginpass>
					<cfset setCookie("dbxlogin","loggedin",dbx.enckey,"SESSION")>
					<cfset dbxr.dodsn = 1>
					<cfset dbxr.loggedin = true>
				<cfelse>
					<cfset dbxr.loginmessage = "<span class=""warning"">Invalid password.  Please try again.</span>">
					<cfset dbxr.jsFocus = "login">
				</cfif>
			<!--- <cfelse>
				<cfset dbxr.jsFocus = "dbdsn">
				<cfset dbxr.dodsn = 1>
			</cfif> --->
		</cfif>	
	
	<cfelse>
		<cfset setCookie("dbxlogin","loggedin",dbx.enckey,"SESSION")>
		<cfset dbxr.loggedin = true>
		<cfset dbxr.dodsn = 1>
	</cfif>
	
	<cfset dbxr.trydsn = "">
	
	<cfif isdefined("form.dbdsn")>
	
		<cfif not isdefined("form.persistdsn")>
			<cfset setCookie("dbxpersistdsn","0",dbx.enckey)>
		</cfif>
	
		<cfif isdefined("form.dbdsnlist") and len(form.dbdsnlist)>
			<cfset form.dbdsn = form.dbdsnlist>
		</cfif>
		
		<cfif len(form.dbdsn)>
			<cfset dbxr.trydsn = form.dbdsn>
		</cfif>
	
		<cfif len(dbxr.trydsn)>
			<!--- try to connect to the db --->
			<cfset dbxr.dsnok = true>
				<cfinclude template="i_trydsn.cfm">
				<cfif not dbxr.dsnok>
					<cfset dbxr.message = dbxr.message & "<span class=""warning"">You must specify a valid #dbx.supportedDBMS# DSN (datasource).</span>">
					<cfset dbxr.jsFocus = "dbdsn">
				</cfif>
			<cfif dbxr.dsnok>
				<cfset setCookie("dbxdsn","#dbxr.trydsn#|#form.dbuser#|#form.dbpass#",dbx.enckey)>
				<!--- <cfif isdefined("cookie.dbxcodegendsn")> --->
					<cfif isboolean(listgetat(getCookie("dbxcodegendsn",dbx.enckey),1,"|"))>
						<cfif not listgetat(getCookie("dbxcodegendsn",dbx.enckey),1,"|")>
							<cfset setCookie("dbxcodegendsn","false|#dbxr.trydsn#|#form.dbuser#|#form.dbpass#",dbx.enckey)>
							<cfset dbxcodegendsn = dbxr.trydsn>
							<cfset dbxcodegenuser = form.dbuser>
							<cfset dbxcodegenpass = form.dbpass>
						<cfelse>
							<cfset dbxcodegendsn = dbxr.trydsn>
							<cfset dbxcodegenuser = form.dbuser>
							<cfset dbxcodegenpass = form.dbpass>
						</cfif>
					<cfelse>
						<cfset setCookie("dbxcodegendsn","false|#dbxr.trydsn#|#form.dbuser#|#form.dbpass#",dbx.enckey)>
					</cfif><!--- 
				<cfelse>
					<cfset setCookie("dbxcodegendsn","false|#dbxr.trydsn#|#form.dbuser#|#form.dbpass#",dbx.enckey)>
				</cfif> --->
				
				<cfif isdefined("form.persistdsn")>
					<cfset setCookie("dbxpersistdsn","#dbxr.trydsn#",dbx.enckey)>
				</cfif>
				
				<cfset dbdsn = dbxr.trydsn>
				<cfset dbuser = form.dbuser>
				<cfset dbpass = form.dbpass>
					
			</cfif>
			
		<cfelse>
			<cfset dbxr.dsnok = 0>
			<cfset dbxr.message = dbxr.message & "<span class=""warning"">You must specify a valid #dbx.supportedDBMS# DSN (datasource).</span>">
			<cfset dbxr.jsFocus = "dbdsn">
		</cfif>
	</cfif>
	
	<cfif listlen(getCookie("dbxdsn",dbx.enckey),"|") and listfirst(getCookie("dbxdsn",dbx.enckey),"|") neq "0">
		<cfset dbdsn = listgetat(getCookie("dbxdsn",dbx.enckey),1,"|")>
			<cfif listlen(getCookie("dbxdsn",dbx.enckey),"|") gt 1>
				<cfset dbuser = listgetat(getCookie("dbxdsn",dbx.enckey),2,"|")>
				<cfif listlen(getCookie("dbxdsn",dbx.enckey),"|") gt 2>
					<cfset dbpass = listgetat(getCookie("dbxdsn",dbx.enckey),3,"|")>
				</cfif>
			<cfelse>
				<cfset dbuser = "">
				<cfset dbpass = "">
			</cfif>
	</cfif>
	
	<cfset dbxcodegendsn = "">
	<cfset dbxcodegenuser = "">
	<cfset dbxcodegenpass = "">
			
	<cfif listlen(getCookie("dbxcodegendsn",dbx.enckey),"|") and listfirst(getCookie("dbxcodegendsn",dbx.enckey),"|") neq "0">
		<cfif listlen(getCookie("dbxcodegendsn",dbx.enckey),"|") gte 2>
			<cfset dbxcodegendsn = listgetat(getCookie("dbxcodegendsn",dbx.enckey),2,"|")>
		<cfelse>
			<cfset dbxcodegendsn = dbxr.trydsn>
		</cfif>
		<cfif listlen(getCookie("dbxcodegendsn",dbx.enckey),"|") gte 3>
			<cfset dbxcodegenuser = listgetat(getCookie("dbxcodegendsn",dbx.enckey),3,"|")>
			<cfif listlen(getCookie("dbxcodegendsn",dbx.enckey),"|") gte 4>
				<cfset dbxcodegenpass = listgetat(getCookie("dbxcodegendsn",dbx.enckey),4,"|")>
			</cfif>
		<cfelse>
			<cfset dbxcodegenuser = "">
			<cfset dbxcodegenpass = "">
		</cfif>
	</cfif>
	
	<cfif listlen(getCookie("dbxprefs",dbx.enckey),"|") and listfirst(getCookie("dbxprefs",dbx.enckey),"|") neq "0">
		<cfif listlen(getCookie("dbxprefs",dbx.enckey),"|")>
			<cfset dbxcodegenprefix = listgetat(getCookie("dbxprefs",dbx.enckey),1,"|")>
		<cfelse>
			<cfset dbxcodegenprefix = "qry%method%">
		</cfif>
	<cfelse>
		<cfset dbxcodegenprefix = "qry%method%">
	</cfif>

	<cfif isdefined("form.ordbuser") and isdefined("form.ordbpass")><!--- an attempt to override default dsn values to gain elevated permissions --->
		<cfset dbuser = form.ordbuser>
		<cfset dbpass = form.ordbpass>
		
		<cfif isdefined("form.ordbpersist") and val(form.ordbpersist)>
			<cfset setCookie("dbxor","#form.ordbuser#|#form.ordbpass#",dbx.enckey)>
		<cfelse>
			<cfset purgeCookie("dbxor")>
		</cfif>
	</cfif>
	
	<cfset dbxr.datasource = structnew()>
	<cfset dbxr.datasource.dsn = ""><!--- dbdsn> --->
	<cfset dbxr.datasource.username = "">
	<cfset dbxr.datasource.password = "">
	
	<cfset dbxr.ordbuser = "">
	<cfset dbxr.ordbpass = "">
	
	<cfif isdefined("cookie.dbxor")>
		<cfif listlen(getCookie("dbxor",dbx.enckey),"|") eq 2>
			<cfset dbxr.ordbuser = listgetat(getCookie("dbxor",dbx.enckey),1,"|")>
			<cfset dbxr.ordbpass = listgetat(getCookie("dbxor",dbx.enckey),2,"|")>
		</cfif>
	</cfif>

<cfsetting enablecfoutputonly = "no">