<cfsetting enablecfoutputonly="yes">
	
	<cffunction name="formatObjectLink" hint="Returns a link string for various object types" access="public" output="no" returntype="string">
		<cfargument name="text" required="false" type="string" default="">
		<cfargument name="type" required="false" type="string" default="">
		<cfargument name="owner" required="false" type="string" default="">
		<cfargument name="target" required="false" type="string" default="detail" hint="detail,opener">
		<cfargument name="linkclass" required="false" type="string" default="" hint="classes to assign to link">

		<cfset var targetstring = "">
		<cfset var targetstringsuffix = "">
		<cfset var classstring = "">

		<cfif not len(arguments.text)><!--- nothing to do --->
			<cfreturn "">
		<cfelseif len(arguments.text) and not len(arguments.type)><!--- text only --->
			<cfreturn arguments.text>
		</cfif>

		<cfif arguments.target eq "opener">
			<cfset targetstring = 'window.opener.location.href'>
			<cfset targetstringsuffix = 'window.opener.focus(); '>
		<cfelseif len(arguments.target)>
			<cfset targetstring = 'window.top.frames[''#arguments.target#''].location.href'>
		</cfif>

		<cfif len(arguments.linkclass)>
			<cfset classstring = ' class="#arguments.linkclass#'>
		</cfif>

		<cfswitch expression="#ucase(arguments.type)#">
			<cfcase value="TABLE,U" delimiters=",">
				<cfreturn '<a href="##"#classstring# onclick="#targetstring#=''index.cfm?frame=detail&oid=#urlencodedformat(arguments.text)#&owid=#arguments.owner#''; #targetstringsuffix#return false;">[#arguments.owner#] #arguments.text#</a>'>
			</cfcase>
			<cfcase value="VIEW,V" delimiters=",">
				<cfreturn '<a href="##"#classstring# onclick="#targetstring#=''index.cfm?frame=detail&oid=#urlencodedformat(arguments.text)#&owid=#arguments.owner#&v=1''; #targetstringsuffix#return false;">[#arguments.owner#] #arguments.text#</a>'>
			</cfcase>
			<cfcase value="PROCEDURE,P" delimiters=",">
				<cfreturn '<a href="##"#classstring# onclick="#targetstring#=''index.cfm?frame=detail&oid=#urlencodedformat(arguments.text)#&owid=#arguments.owner#&sp=1''; #targetstringsuffix#return false;">[#arguments.owner#] #arguments.text#</a>'>
			</cfcase>
			<cfcase value="FUNCTION,FN,TF,IF" delimiters=",">
				<cfreturn '<a href="##"#classstring# onclick="#targetstring#=''index.cfm?frame=detail&oid=#urlencodedformat(arguments.text)#&owid=#arguments.owner#&sp=1&fn=1''; #targetstringsuffix#return false;">[#arguments.owner#] #arguments.text#</a>'>
			</cfcase>
			<!--- <cfcase value="TRIGGER" delimiters=",">
				<a href="##"#classstring# onclick="#targetstring#='index.cfm?frame=detail&oid=#urlencodedformat(parent_obj)#&owid=#arguments.owner#'; #targetstringsuffix#return false;">[#arguments.owner#] #arguments.text#</a>
			</cfcase> --->
			<cfdefaultcase>
				<cfreturn arguments.text>
			</cfdefaultcase>
		</cfswitch>


	</cffunction>
	
<cfsetting enablecfoutputonly="no">


	