<cfsetting enablecfoutputonly="yes">
	
	<cffunction name="formatSize" hint="Returns a formatted size string based on numeric input" access="public" output="no" returntype="string">
		<cfargument name="size" required="yes" type="numeric">
		<cfargument name="increment" required="yes" type="string"><!--- b,kb,mb,gb --->
		<cfargument name="mode" required="false" type="string" default="simple"><!--- none: simply numberformat()'s the size and returns the same value; simple: evaluates sizes into the appropriate increment (b, kb, mb, gb, tb); composite: returns both the original value with the evaluated size in parentheses   --->

		<cfset var text = "">
		<cfset var comp = "">
		
		<cfif not listfindnocase("none,simple,composite",arguments.mode)>
			<cfset arguments.mode = "simple">
		</cfif>
		
		<cfif arguments.mode eq "none">
			<cfreturn "#numberformat(arguments.size)# #ucase(arguments.increment)#">
		<cfelseif arguments.mode eq "simple">
			<cfset text = "">
		<cfelse>
			<cfset text = "#numberformat(arguments.size)# #ucase(arguments.increment)#">
		</cfif>
		
		<cfif arguments.increment eq "b"><!--- working with bytes --->
			<cfif arguments.size lt 1024><!--- in b --->
				<cfset comp = "#numberformat(arguments.size)# B">
			<cfelseif arguments.size lt 1048576><!--- in kb --->
				<cfset comp = "#decimalformat((arguments.size/1024))# KB">		
				<cfif arguments.mode eq "composite">
					<cfset comp = text & " (#comp#)">
				</cfif>	
			<cfelseif arguments.size lt 1073741824><!--- in mb --->
				<cfset comp = "#decimalformat((arguments.size/1024/1024))# MB">		
				<cfif arguments.mode eq "composite">
					<cfset comp = text & " (#comp#)">
				</cfif>	
			<cfelseif arguments.size lt 1099511627776><!--- in gb --->
				<cfset comp = "#decimalformat((arguments.size/1024/1024/1024))# GB">		
				<cfif arguments.mode eq "composite">
					<cfset comp = text & " (#comp#)">
				</cfif>	
			<cfelse><!--- in tb --->
				<cfset comp = "#decimalformat((arguments.size/1024/1024/1024/1024))# TB">		
				<cfif arguments.mode eq "composite">
					<cfset comp = text & " (#comp#)">
				</cfif>	
			</cfif>
		<cfelseif arguments.increment eq "kb"><!--- working with kilobytes --->
			<cfif arguments.size lt 1024><!--- in kb --->
				<cfset comp = "#numberformat(arguments.size)# KB">
			<cfelseif arguments.size lt 1048576><!--- in mb --->
				<cfset comp = "#decimalformat((arguments.size/1024))# MB">		
				<cfif arguments.mode eq "composite">
					<cfset comp = text & " (#comp#)">
				</cfif>	
			<cfelseif arguments.size lt 1073741824><!--- in gb --->
				<cfset comp = "#decimalformat((arguments.size/1024/1024))# GB">	
				<cfif arguments.mode eq "composite">
					<cfset comp = text & " (#comp#)">
				</cfif>
			<cfelse><!--- in tb --->
				<cfset comp = "#decimalformat((arguments.size/1024/1024/1024))# TB">			
				<cfif arguments.mode eq "composite">
					<cfset comp = text & " (#comp#)">
				</cfif>
			</cfif>
		<cfelseif arguments.increment eq "mb"><!--- working with megabytes --->
			<cfif arguments.size lt 1024><!--- in mb --->
				<cfset comp = "#numberformat(arguments.size)# MB">
			<cfelseif arguments.size lt 1048576><!--- in gb --->
				<cfset comp = "#decimalformat((arguments.size/1024))# GB">	
				<cfif arguments.mode eq "composite">
					<cfset comp = text & " (#comp#)">
				</cfif>
			<cfelse><!--- in tb --->
				<cfset comp = "#decimalformat((arguments.size/1024/1024))# TB">		
				<cfif arguments.mode eq "composite">
					<cfset comp = text & " (#comp#)">
				</cfif>	
			</cfif>
		<cfelseif arguments.increment eq "gb"><!--- working with gigabytes --->
			<cfif arguments.size lt 1024><!--- in gb --->
				<cfset comp = "#numberformat(arguments.size)# GB">
			<cfelseif arguments.size lt 1048576><!--- in gb --->
			<cfelse><!--- in tb --->
				<cfset comp = "#decimalformat((arguments.size/1024))# TB">			
				<cfif arguments.mode eq "composite">
					<cfset comp = text & " (#comp#)">
				</cfif>
			</cfif>
		<cfelse>
			<cfset comp = "#numberformat(arguments.size)# #ucase(arguments.increment)#">
		</cfif>
		
		<cfreturn comp>

	</cffunction>
	
<cfsetting enablecfoutputonly="no">


	