<cfsetting enablecfoutputonly="yes">

	<!--- 
	Details/Copyright ______________________________________________________
	
	  Type: 		UDF
	  Name:		 	verifyIP( IP, mask )
	  Version:		1.0 4/25/2003
	  Author:		Kevin J. Miller (kmiller@websolete.com)
	  URL:			http://www.websolete.com
	  Copyright  2002-2004 Kevin J. Miller.  Please see terms of use below.
	 
	Version Notes _________________________________________________________
	 
		v1.0 4/25/2003
		- Initial version
		
	Description ___________________________________________________________
	
		Takes a an IP and verifies it against the mask provided, mask allows wildcards. 
		Returns a boolean value based on whether the IP was validated against the mask.
		
	Usage _______________________________________________________________
	
		verifyIP ( IP, mask)
		IP : the ip to check against the mask
		mask : use * for wildcards.  Valid examples are: 121.22.223.14 or 121.22.*.* etc.
		
		Example: 
			<cfset ipOK = verifyIP('121.22.223.14','121.22.*.*')>
		
		Returns:
			Boolean.
	
	--->
	
	<cfscript>
	function verifyIP( IP, mask) { 
		var ipOK = false; 
		
		// ip and mask must have 4 octet positions
		if(listlen(IP,".") neq 4 OR listlen(mask,".") neq 4) {
			//Invalid IP or mask passed. Aborting.
			return false;
		}
	
		ipOK = true;
		
		// loop the mask
		for(i=1; i lte 4; i = i + 1) {
			if(listgetat(mask,i,".") neq "*") { // not a wildcard
				if(listgetat(mask,i,".") neq listgetat(IP,i,".")){ // didn't match
					dbxr.ipOK = false;
					break;
				} 
			}
		}
	
		return ipOK;
		
	}
	</cfscript>
	
<cfsetting enablecfoutputonly="no">