
		<!--- for controlling fulltext focused details below --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="checkFT">
			SELECT hasFTinstalled = FULLTEXTSERVICEPROPERTY('IsFulltextInstalled')
		</cfquery>

		<cfset hasFT = checkFT.hasFTinstalled>
		
		<cfif isdefined("url.cfg")>
			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="config">
					SELECT 
					text1 = 'Number of opened or attempted connections', label1 = '@@CONNECTIONS', data1 = @@CONNECTIONS, 
					text2 = 'Current value of the SET DATEFIRST parameter', label2 = '@@DATEFIRST', data2 = CASE @@DATEFIRST WHEN 1 THEN 'Monday (1)' WHEN 2 THEN 'Tuesday (2)' WHEN 3 THEN 'Wednesday (3)' WHEN 4 THEN 'Thursday (4)' WHEN 5 THEN 'Friday (5)' WHEN 6 THEN 'Saturday (6)' ELSE 'Sunday (7)' END,  
					text3 = 'Name of the language currently in use', label3 = '@@LANGUAGE', data3 = @@LANGUAGE,
					text4 = 'ID of the language currently in use', label4 = '@@LANGID', data4 = @@LANGID, 
					text5 = 'Lock time-out setting for the current session', label5 = '@@LOCK_TIMEOUT', data5 = @@LOCK_TIMEOUT,
					text6 = 'Max number of simultaneous user connections', label6 = '@@MAX_CONNECTIONS', data6 = @@MAX_CONNECTIONS,
					text7 = 'Precision level used by decimal and numeric data types', label7 = '@@MAX_PRECISION', data7 = @@MAX_PRECISION, 
					text8 = 'Information about the current SET options', label8 = '@@OPTIONS', data8 = @@OPTIONS, 
					text9 = 'Name of the remote SQL Server database server', label9 = '@@REMSERVER', data9 = ISNULL(@@REMSERVER,'NULL'), 
					text10 = 'Name of the local server running SQL Server', label10 = '@@SERVERNAME', data10 = @@SERVERNAME, 
					text11 = 'Current value of the TEXTSIZE option', label11 = '@@TEXTSIZE', data11 = @@TEXTSIZE, 
					text12 = 'Date, version and cpu information for the current installation', label12 = '@@VERSION', data12 = @@VERSION, 
					text13 = 'The name of the default collation for the server', label13 = 'Collation', data13 = serverproperty('collation'),
					text14 = 'The edition of the SQL Server instance installed on the server', label14 = 'Edition', data14 = serverproperty('edition'),
					text15 = 'The engine edition of the SQL Server instance installed on the server', label15 = 'Engine Edition', data15 = CASE CAST(serverproperty('engine edition') AS int) WHEN 1 THEN 'Personal or Desktop Engine (1)' WHEN 2 THEN 'Standard (2)' WHEN 3 THEN 'Enterprise (3)' ELSE 'Unknown (' + ISNULL(CAST(serverproperty('engine edition') AS nvarchar),'NULL') + ')' END,
					text16 = 'The name of the instance to which connection is established', label16 = 'Instancename', data16 = ISNULL(serverproperty('instancename'),'NULL'),
					text17 = 'The server instance is configured in a failover cluster', label17 = 'IsClustered', data17 = CASE CAST(serverproperty('isclustered') AS int) WHEN 1 THEN 'Clustered' ELSE 'Not Clustered' END,
					text18 = 'The full-text component is installed with the current instance of SQL Server', label18 = 'IsFullTextInstalled', data18 = CASE CAST(serverproperty('isfulltextinstalled') AS int) WHEN 1 THEN 'Yes' ELSE 'No' END,
					text19 = 'The server is in integrated security mode', label19 = 'IsIntegratedSecurityOnly', data19 = CASE CAST(serverproperty('isintegratedsecurityonly') AS int) WHEN 1 THEN 'Yes' ELSE 'No' END,
					text20 = 'Windows NT computer name on which the server instance is running', label20 = 'MachineName', data20 = serverproperty('machinename'),
					text21 = 'The version of the instance of SQL Server, in the form of *major.minor.build*', label21 = 'ProductVersion', data21 = serverproperty('productversion'), 
					numValues = 21 
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset config = querynew("nothing")>
			</cfcatch>
			</cftry>

			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="jobconfig">
					/*******************************************************************************
					
					Name:			GetJobSchedule	(For SQL Server7.0&2000)
					
					Author:			M.Pearson
					Modified By:		M.Austin, KjM 
					Creation Date:		5 Jun 2002
					Version:		1.0
					
					
					Program Overview:	This queries the sysjobs, sysjobschedules and sysjobhistory table to
								produce a resultset showing the jobs on a server plus their schedules
								(if applicable) and the maximun duration of the job.
								
								The UNION join is to cater for jobs that have been scheduled but not yet
								run, as this information is stored in the 'active_start...' fields of the 
								sysjobschedules table, whereas if the job has already run the schedule 
								information is stored in the 'next_run...' fields of the sysjobschedules table.
					
					
					Modification History:
					-------------------------------------------------------------------------------
					Version Date		Name		Modification
					-------------------------------------------------------------------------------
					1.0 	5  Jun 2002	M.Pearson	Inital Creation
					1.1	15 Dec 2003     M. Austin	Added How often it occurs on and at what interval
					1.2	16 Dec 2003	M. Austin	Added Last Duration and Last Run Status
					1.2	16 Dec 2003	M. Austin	Made it a Procedure
					1.21 15 Mar 2004 KjM Changed to a straight query from  proc for use in DBX
					
					*******************************************************************************/

					USE [msdb] 
					
					SELECT dbo.sysjobs.Name AS 'JobName', 
						'JobEnabled' = CASE dbo.sysjobs.Enabled
							WHEN 1 THEN 'Yes'
							WHEN 0 THEN 'No'
						END,
						'ScheduleEnabled' = CASE dbo.sysjobschedules.Enabled
							WHEN 1 THEN 'Yes'
							WHEN 0 THEN 'No'
						END,
						'Frequency' = CASE freq_type
							WHEN 1 THEN 'Once'
							WHEN 4 THEN 'Daily'
							WHEN 8 THEN 'Weekly'
							WHEN 16 THEN 'Monthly'
							WHEN 32 THEN 'Monthly relative'
							WHEN 64 THEN 'When SQLServer Agent starts'
						END, 
						'OccursEvery'=freq_subday_interval,
					'SubFreqInterval'=  Case  freq_subday_type 
										when 4 then 'Minutes' 
										When 8 then 'Hours'
									  End,
						'StartDate' = CASE active_start_date
							WHEN 0 THEN null
							ELSE
							substring(convert(varchar(15),active_start_date),1,4) + '/' + 
							substring(convert(varchar(15),active_start_date),5,2) + '/' + 
							substring(convert(varchar(15),active_start_date),7,2)
						END,
						'StartTime' = CASE len(active_start_time)
							WHEN 3 THEN cast('00:0' 
									+ Left(right(active_start_time,3),1)  
									+':' + right(active_start_time,2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(active_start_time,4),2)  
									+':' + right(active_start_time,2) as char (8))
							WHEN 5 THEN cast('0' 
									+ Left(right(active_start_time,5),1) 
									+':' + Left(right(active_start_time,4),2)  
									+':' + right(active_start_time,2) as char (8))
							WHEN 6 THEN cast(Left(right(active_start_time,6),2) 
									+':' + Left(right(active_start_time,4),2)  
									+':' + right(active_start_time,2) as char (8))
						END,
						isnull(CASE len(Q1.run_duration)
							WHEN 1 THEN cast('00:00:0'
									+ cast(Q1.run_duration as char) as char (8))
							WHEN 2 THEN cast('00:00:'
									+ cast(Q1.run_duration as char) as char (8))
							WHEN 3 THEN cast('00:0' 
									+ Left(right(Q1.run_duration,3),1)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 5 THEN cast('0' 
									+ Left(right(Q1.run_duration,5),1) 
									+':' + Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 6 THEN cast(Left(right(Q1.run_duration,6),2) 
									+':' + Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
						END,'NA') as 'MaxDuration',
							isnull(CASE len(Q2.[LastDuration])
							WHEN 1 THEN cast('00:00:0'
									+ cast(Q2.[LastDuration] as char) as char (8))
							WHEN 2 THEN cast('00:00:'
									+ cast(Q2.[LastDuration] as char) as char (8))
							WHEN 3 THEN cast('00:0' 
									+ Left(right(Q2.[LastDuration],3),1)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 5 THEN cast('0' 
									+ Left(right(Q2.[LastDuration],5),1) 
									+':' + Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 6 THEN cast(Left(right(Q2.[LastDuration],6),2) 
									+':' + Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
						END,'NA') as 'LastDuration',
					'LastRunStatus'=isnull(Case when Q2.run_status =1  then 'Succeeded' when Q2.run_status=0 then 'Failed' End,'NA')
					FROM dbo.sysjobs 
					LEFT OUTER JOIN dbo.sysjobschedules 
					ON dbo.sysjobs.job_id = dbo.sysjobschedules.job_id
					LEFT OUTER JOIN (SELECT job_id, max(run_duration) AS run_duration
							FROM dbo.sysjobhistory
							GROUP BY job_id) Q1
					ON dbo.sysjobs.job_id = Q1.job_id
					Left outer join (select T0.job_id,T0.run_status,'LastDuration'=T0.run_duration from sysjobhistory T0
					inner join 
					(select job_id,'Instance_id'=max(instance_id) FROM dbo.sysjobhistory where  step_id=1 GROUP BY job_id ) T1
					On
					T0.job_id=T1.job_id and
					T0.instance_id=T1.instance_id) Q2
					ON dbo.sysjobs.job_id = Q2.job_id
					WHERE Next_run_time = 0
					
					UNION
					
					SELECT dbo.sysjobs.Name AS 'JobName', 
						'Job Enabled' = CASE dbo.sysjobs.Enabled
							WHEN 1 THEN 'Yes'
							WHEN 0 THEN 'No'
						END,
						'ScheduleEnabled' = CASE dbo.sysjobschedules.Enabled
							WHEN 1 THEN 'Yes'
							WHEN 0 THEN 'No'
						END,
						'Frequency' = CASE freq_type
							WHEN 1 THEN 'Once'
							WHEN 4 THEN 'Daily'
							WHEN 8 THEN 'Weekly'
							WHEN 16 THEN 'Monthly'
							WHEN 32 THEN 'Monthly relative'
							WHEN 64 THEN 'When SQLServer Agent starts'
						END, 
						'OccursEvery'=freq_subday_interval,
						'SubFreqInterval'=  Case  freq_subday_type 
										when 4 then 'Minutes' 
										When 8 then 'Hours'
									  End,
						'StartDate' = CASE next_run_date
							WHEN 0 THEN null
							ELSE
							substring(convert(varchar(15),next_run_date),1,4) + '/' + 
							substring(convert(varchar(15),next_run_date),5,2) + '/' + 
							substring(convert(varchar(15),next_run_date),7,2)
						END,
						'StartTime' = isnull(CASE len(next_run_time)
							WHEN 3 THEN cast('00:0' 
									+ Left(right(next_run_time,3),1)  
									+':' + right(next_run_time,2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(next_run_time,4),2)  
									+':' + right(next_run_time,2) as char (8))
							WHEN 5 THEN cast('0' + Left(right(next_run_time,5),1) 
									+':' + Left(right(next_run_time,4),2)  
									+':' + right(next_run_time,2) as char (8))
							WHEN 6 THEN cast(Left(right(next_run_time,6),2) 
									+':' + Left(right(next_run_time,4),2)  
									+':' + right(next_run_time,2) as char (8))
						END,'NA'),
						isnull(CASE len(Q1.run_duration)
							WHEN 1 THEN cast('00:00:0'
									+ cast(Q1.run_duration as char) as char (8))
							WHEN 2 THEN cast('00:00:'
									+ cast(Q1.run_duration as char) as char (8))
							WHEN 3 THEN cast('00:0' 
									+ Left(right(Q1.run_duration,3),1)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 5 THEN cast('0' 
									+ Left(right(Q1.run_duration,5),1) 
									+':' + Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 6 THEN cast(Left(right(Q1.run_duration,6),2) 
									+':' + Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
						END,'NA') as 'Max Duration',
						isnull(CASE len(Q2.[LastDuration])
							WHEN 1 THEN cast('00:00:0'
									+ cast(Q2.[LastDuration] as char) as char (8))
							WHEN 2 THEN cast('00:00:'
									+ cast(Q2.[LastDuration] as char) as char (8))
							WHEN 3 THEN cast('00:0' 
									+ Left(right(Q2.[LastDuration],3),1)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 5 THEN cast('0' 
									+ Left(right(Q2.[LastDuration],5),1) 
									+':' + Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 6 THEN cast(Left(right(Q2.[LastDuration],6),2) 
									+':' + Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
						END,'NA') as 'LastDuration',
					'LastRunStatus'=isnull(Case when Q2.run_status =1  then 'Succeeded' when Q2.run_status=0 then 'Failed' End,'NA')
					FROM dbo.sysjobs 
					LEFT OUTER JOIN dbo.sysjobschedules ON dbo.sysjobs.job_id = dbo.sysjobschedules.job_id
					LEFT OUTER JOIN (SELECT job_id, max(run_duration) AS run_duration
							FROM dbo.sysjobhistory
							GROUP BY job_id) Q1
					ON dbo.sysjobs.job_id = Q1.job_id
					Left outer join (select T0.job_id,T0.run_status,'LastDuration'=T0.run_duration from sysjobhistory T0
					inner join 
					(select job_id,'Instance_id'=max(instance_id) FROM dbo.sysjobhistory where  step_id=1 GROUP BY job_id ) T1
					On
					T0.job_id=T1.job_id and
					T0.instance_id=T1.instance_id) Q2
					ON dbo.sysjobs.job_id = Q2.job_id
					WHERE Next_run_time <> 0
					
					ORDER BY [StartDate],[StartTime]
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset queryError = "#cfcatch.message# #cfcatch.detail#">
				<cfset jobconfig = querynew("nothing")>
			</cfcatch>
			</cftry>
		
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>
				
		<cfelseif isdefined("url.dbcfg")>
			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="fulltextconfig">
					SELECT [name], 
					populatestatus = CASE FULLTEXTCATALOGPROPERTY([name],'PopulateStatus') 
					WHEN 0 THEN 'Idle' WHEN 1 THEN 'Population in progress' WHEN 2 THEN 'Paused' 
					WHEN 3 THEN 'Throttled' WHEN 4 THEN 'Recovering' WHEN 5 THEN 'Shutdown' 
					WHEN 6 THEN 'Incremental Population in progress' WHEN 7 THEN 'Updating index' ELSE 'Unknown' END,
					FULLTEXTCATALOGPROPERTY([name],'ItemCount') AS itemcount,
					FULLTEXTCATALOGPROPERTY([name],'IndexSize') AS indexsize, 
					FULLTEXTCATALOGPROPERTY([name],'UniqueKeyCount') AS uniquekeycount, 
					FULLTEXTCATALOGPROPERTY([name],'LogSize') AS logsize,
					FULLTEXTCATALOGPROPERTY([name],'PopulateCompletionAge') AS populatecompletionage, 
					DATEDIFF(s,'01/01/1990',getdate()) AS agenow  
					FROM sysfulltextcatalogs	
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset fulltextconfig = querynew("nothing")>
			</cfcatch>
			</cftry>
			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="dbconfig">
					SELECT 
					databaseName = '#defaultdb.name#', 
					text1 = 'Database follows ANSI-92 standard for NULL values', label1 = 'IsAnsiNullDefault', data1 = CASE DATABASEPROPERTY('#defaultdb.name#','IsAnsiNullDefault') WHEN 0 THEN 'No' ELSE 'Yes' END,
					text2 = 'All comparisons made with a NULL cannot be evaluated', label2 = 'IsAnsiNullsEnabled', data2 = CASE DATABASEPROPERTY('#defaultdb.name#','') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text3 = 'Warning messages are issued when standard error conditions occur', label3 = 'IsAnsiWarningsEnabled', data3 = CASE DATABASEPROPERTY('#defaultdb.name#','IsAnsiWarningsEnabled') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text4 = 'Database frees resources after the last user has exited', label4 = 'IsAutoClose', data4 = CASE DATABASEPROPERTY('#defaultdb.name#','IsAutoClose') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text5 = 'Database files can be shrunk automatically and periodically', label5 = 'IsAutoShrink', data5 = CASE DATABASEPROPERTY('#defaultdb.name#','IsAutoShrink') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text6 = 'Autoupdate statistics option has been enabled', label6 = 'IsAutoUpdateStatistics', data6 = CASE DATABASEPROPERTY('#defaultdb.name#','IsAutoUpdateStatistics') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text7 = 'Database allows non-logged operations (e.g., bulk copy program)', label7 = 'IsBulkCopy', data7 = CASE DATABASEPROPERTY('#defaultdb.name#','IsBulkCopy') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text8 = 'Any cursors that are open when a transaction is committed will be closed', label8 = 'IsCloseCursorsOnCommitEnabled', data8 = CASE DATABASEPROPERTY('#defaultdb.name#','IsCloseCursorsOnCommitEnabled') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text9 = 'Database is only accessible by dbo', label9 = 'IsDboOnly', data9 = CASE DATABASEPROPERTY('#defaultdb.name#','IsDboOnly') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text10 = 'Cursor declarations default to LOCAL', label10 = 'IsLocalCursorsDefault', data10 = CASE DATABASEPROPERTY('#defaultdb.name#','IsLocalCursorsDefault') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text11 = 'Concatenating to a NULL results in a NULL', label11 = 'IsNullConcat', data11 = CASE DATABASEPROPERTY('#defaultdb.name#','IsNullConcat') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text12 = 'Identifiers can be delimited by double quotation marks', label12 = 'IsQuotedIdentifiersEnabled', data12 = CASE DATABASEPROPERTY('#defaultdb.name#','IsQuotedIdentifiersEnabled') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text13 = 'Database is in read-only mode', label13 = 'IsReadOnly', data13 = CASE DATABASEPROPERTY('#defaultdb.name#','IsReadOnly') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text14 = 'Recursive firing of triggers is enabled', label14 = 'IsRecursiveTriggersEnabled', data14 = CASE DATABASEPROPERTY('#defaultdb.name#','IsRecursiveTriggersEnabled') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text15 = 'The database truncates its log on checkpoints', label15 = 'IsTruncLog', data15 = CASE DATABASEPROPERTY('#defaultdb.name#','IsTruncLog') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text16 = 'Internal version number of the SQL Server code with which the database was created', label16 = 'Version', data16 = DATABASEPROPERTY('#defaultdb.name#','Version'), 
					text17 = 'Database has been full-text enabled', label17 = 'IsFullTextEnabled', data17 = CASE DATABASEPROPERTY('#defaultdb.name#','IsFullTextEnabled') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text18 = 'Simple, Full, or Bulk-Logged', label18 = 'Recovery Model', data18 = DATABASEPROPERTYEX('#defaultdb.name#','Recovery'), 
					numValues = 18 
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset dbconfig = querynew("nothing")>
			</cfcatch>
			</cftry>
			
			<!--- table row counts --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="tablerowtotals">
					CREATE TABLE ##trt (
						tblName varchar(255), 
						rowTotal int, 
						reserved varchar(20), 
						data varchar(20), 
						index_size varchar(20),
						unused varchar(20) 
					); 

					EXEC sp_MSforeachtable @command1='INSERT ##trt EXEC sp_spaceused ''?''';
					
					SELECT * FROM ##trt ORDER BY tblName; 
					
					DROP TABLE ##trt; 
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset tablerowtotals = querynew("nothing")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>
			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_extprops">
					SELECT [name],value 
					FROM   ::fn_listextendedproperty (null, null, null, null, null, null, null)
					ORDER BY [name] 
				</cfquery>
				
				<cfcatch>
					<cfset getobject_extprops = querynew("nothing")>
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to get extended property data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
			
		<cfelseif isdefined("url.sp")>
			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
					<cfif not isdefined("url.master")>
						EXEC sp_sproc_columns '#trim(url.oid)#';
					<cfelse>
						USE master; EXEC sp_sproc_columns '#trim(url.oid)#','#trim(url.owid)#'; 
					</cfif>
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset getobject = querynew("nothing")>
			</cfcatch>
			</cftry>
			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_extprops">
					SELECT objname,objtype,[name],value,pos = (CASE e.objtype WHEN 'procedure' THEN 1 WHEN 'function' THEN 1 WHEN 'parameter' THEN 2 ELSE 3 END) FROM (
					SELECT * FROM   ::fn_listextendedproperty (null, 'user', '#url.owid#', '<cfif not isdefined("url.fn")>procedure<cfelse>function</cfif>', '#trim(url.oid)#', null, null)
					UNION 
					SELECT * FROM   ::fn_listextendedproperty (null, 'user', '#url.owid#', '<cfif not isdefined("url.fn")>procedure<cfelse>function</cfif>', '#trim(url.oid)#', 'parameter', null) ) e 
					ORDER BY pos,objname,[name];
				</cfquery>
				
				<cfcatch>
					<cfset getobject_extprops = querynew("nothing")>
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to get extended property data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>

			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="spschema">
					<cfif not isdefined("url.master")>
						EXEC sp_helptext '#trim(url.oid)#';
					<cfelse>
						USE master; EXEC sp_helptext '#trim(url.oid)#'; 
					</cfif>
				</cfquery>
			<cfcatch type="Any">
				<cfset spschema = querynew("text")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>

		<cfelseif isdefined("url.tr")>
			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
					<cfif not isdefined("url.master")>
						SELECT c.text FROM dbo.sysobjects s,dbo.syscomments c 
						WHERE s.name = '#trim(url.oid)#' AND s.id = c.id 
					<cfelse>
						USE master; 
						SELECT c.text FROM dbo.sysobjects s,dbo.syscomments c 
						WHERE s.name = '#trim(url.oid)#' AND s.id = c.id 
					</cfif>
				</cfquery>
			<cfcatch type="Any">
				<cfset getobject = querynew("nothing")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>

			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="trschema">
					<cfif not isdefined("url.master")>
						SELECT c.text FROM dbo.sysobjects s,dbo.syscomments c 
						WHERE s.name = '#trim(url.oid)#' AND s.id = c.id 
					<cfelse>
						USE master; 
						SELECT c.text FROM dbo.sysobjects s,dbo.syscomments c 
						WHERE s.name = '#trim(url.oid)#' AND s.id = c.id 
					</cfif>
				</cfquery>
			<cfcatch type="Any">
				<cfset trschema = querynew("text")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>
					
		<cfelse>
		
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
					<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_columns '#trim(url.oid)#';
				</cfquery>
				<cfset theTableOwner = getobject.table_owner[1]>
				
				<cfcatch>
					<cfset getobject = querynew("nothing")>
					<cfset theTableOwner = "">
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to get object data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
			
			<cfif not isdefined("url.v")>
				
				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_extprops">
						SELECT objname,objtype,[name],value,pos = (CASE e.objtype WHEN 'table' THEN 1 WHEN 'column' THEN 2 ELSE 3 END) FROM (
						SELECT * FROM   ::fn_listextendedproperty (null, 'user', '#theTableOwner#', 'table', '#trim(url.oid)#', null, null)
						UNION 
						SELECT * FROM   ::fn_listextendedproperty (null, 'user', '#theTableOwner#', 'table', '#trim(url.oid)#', 'column', null) ) e 
						ORDER BY pos,objname,[name];
					</cfquery>
					
					<cfcatch>
						<cfset getobject_extprops = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get extended property data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>
			
			<cfelse>
			
				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_extprops">
						SELECT objname,objtype,[name],value,pos = (CASE e.objtype WHEN 'view' THEN 1 WHEN 'column' THEN 2 ELSE 3 END) FROM (
						SELECT * FROM  ::fn_listextendedproperty (null, 'user', '#theTableOwner#', 'view', '#trim(url.oid)#', null, null)
						UNION 
						SELECT * FROM   ::fn_listextendedproperty (null, 'user', '#theTableOwner#', 'view', '#trim(url.oid)#', 'column', null) ) e 
						ORDER BY pos,objname,[name];
					</cfquery>
					
					<cfcatch>
						<cfset getobject_extprops = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get extended property data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>
			
			</cfif>
			
			<cfif not isdefined("url.v") and (not isdefined("url.subframe") or url.subframe eq "top")>
				<cftry>
					
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_keys">
						<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_MStablekeys '#trim(url.oid)#';
					</cfquery>
					
					<cfcatch>
						<cfset getobject_keys = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get object key data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>
				
				<cftry>
					
					<!--- TABLE INDEXES --->
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_indexes">
						<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_helpindex '<cfif url.owid eq "sys">sys.</cfif>#trim(url.oid)#';
					</cfquery>
					
					<cfcatch>
						<cfset getobject_indexes = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get object index data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>
				
				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_refs">
						<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_MStablerefs '#trim(url.oid)#';
					</cfquery>
					
					<cfcatch>
						<cfset getobject_refs = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get object reference data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>
			
				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_space">
						<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_MStablespace '#trim(url.oid)#';
					</cfquery>
					
					<cfcatch>
						<cfset getobject_space = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get object space data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>	

				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_triggers">
						<cfif isdefined("url.master")>USE master; </cfif>
						SELECT s.name,c.text 
						FROM sysobjects s, syscomments c
						WHERE s.id = c.id AND s.parent_obj = (SELECT s2.id FROM sysobjects s2 WHERE s2.id = object_id('#trim(url.oid)#')) AND s.type = 'TR'			
					</cfquery>
					
					<cfcatch>
						<cfset getobject_space = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get object trigger data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>	
				
			</cfif>
			
			<cftry>			
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_deps">
					<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_MSdependencies '#trim(url.oid)#';
				</cfquery>
				
				<cfcatch>
					<cfset getobject_deps = querynew("nothing")>
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to get object dependency data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
			
			<!--- COLUMN DEPENDENCIES --->
			<cftry>			
				<cfif getobject.recordcount>
				
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_coldeps">
						<cfif isdefined("url.master")>USE master; </cfif>						
						SELECT 
							sc.name AS colName, 
							OBJECT_NAME(sd.id) AS depObj,
							(SELECT ltrim(rtrim(xtype)) FROM sysobjects so WHERE so.id = sd.id) AS depObjType, 
							USER_NAME(OBJECTPROPERTY(so.id, 'OwnerID')) AS depObjOwner 
						FROM sysobjects so 
							INNER JOIN syscolumns sc ON so.id = sc.id 
							INNER JOIN sysdepends sd ON so.id = sd.depid and sc.colid = sd.depnumber
						WHERE so.id = OBJECT_ID('<cfif url.owid eq "sys">sys.</cfif>#trim(url.oid)#') 
						ORDER BY sc.name 
					</cfquery>
				
				</cfif>
				
				<cfcatch>
					<cfset getobject_coldeps = querynew("nothing")>
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to get column dependency data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
			
			<cfif not isdefined("url.v") and (not isdefined("url.subframe") or url.subframe eq "top")>
			
			<cftry>
			<cftransaction>
			
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="depstreeCleanUp">
					USE tempdb; 
					IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'##getDependencyTree') ) BEGIN 
						DROP PROCEDURE ##getDependencyTree 
					END
					IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'##depTree') ) BEGIN 
						DROP TABLE ##depTree 
					END
					USE [#defaultdb.name#]; SELECT 1 AS blah; 
					</cfquery>

					<!--- DEPENDENCY TREE --->
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_depstreestep1">
					<cfif isdefined("url.master")>USE master; </cfif>
					CREATE PROCEDURE ##getDependencyTree 
						  @table_name varchar(100) -- the procedure will try to find all the child tables for the table @table_name 
						, @space_len int = -4 output -- for printing position purpose

						AS 

						BEGIN -- sp
							DECLARE @table_owner varchar(100)
						    DECLARE @child varchar(100)
						    SET @space_len = @space_len + 4
						
						    IF @table_name IS NULL
						    BEGIN -- return
						        SET @space_len = @space_len - 4
						        RETURN
						    END -- return 

							SET @table_owner = (SELECT USER_NAME(OBJECTPROPERTY(id, 'OwnerID')) FROM sysobjects WHERE name = @table_name); 
							IF LEN(@table_owner) > 0
							BEGIN 
								SET @table_owner = @table_owner + '.'
							END 
						
						    IF NOT EXISTS (SELECT * FROM sysforeignkeys WHERE rkeyid = OBJECT_ID(@table_name) )
						    BEGIN -- leaf level
						        IF @space_len <= 0 
									INSERT INTO ##depTree (treeitem) VALUES (@table_owner + @table_name) 
						        ELSE 
									INSERT INTO ##depTree (treeitemspace,treeitem) VALUES (space(@space_len) + '|-- ',@table_owner + @table_name) 
						
						        SET @space_len = @space_len - 4
						        RETURN 
						    END -- leaf level
							
						    ELSE  -- the @table_name table exists
						    BEGIN -- else
						        IF @space_len <= 0 
								   INSERT INTO ##depTree (treeitem) VALUES (@table_owner + @table_name) 
						        ELSE 
									INSERT INTO ##depTree (treeitemspace,treeitem) VALUES (space(@space_len) + '|-- ',@table_owner + @table_name) 
						
						        IF EXISTS ( SELECT * FROM sysforeignkeys WHERE rkeyid = OBJECT_ID(@table_name) AND rkeyid = fkeyid) -- self referenced
						           INSERT INTO ##depTree (treeitemspace,treeitem) VALUES (space(@space_len) + '|-- ',@table_owner + @table_name) 
						
						        DECLARE curChild CURSOR LOCAL FOR 
						        SELECT OBJECT_NAME(fkeyid) AS child FROM sysforeignkeys
						        WHERE rkeyid = OBJECT_ID(@table_name) AND rkeyid <> fkeyid 
						
						        OPEN curChild
						        FETCH NEXT FROM curChild INTO @child
						        
						        WHILE @@fetch_status = 0
						         BEGIN  -- cursor loop
						             EXEC ##getDependencyTree @table_name = @child, @space_len = @space_len output 
						             FETCH NEXT FROM curChild INTO @child
						          END -- cursor loop
						
						           CLOSE curChild
						           DEALLOCATE curChild
						        END --else
						        SET @space_len = @space_len - 4
						        RETURN 
						END --sp 
					</cfquery>
					
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_depstree">
						SET NOCOUNT OFF;
						<cfif isdefined("url.master")>USE master; </cfif>
						CREATE TABLE ##depTree (treeitemspace varchar(100),treeitem varchar(255));
						EXEC ##getDependencyTree '#trim(url.oid)#'; 
						SELECT treeitemspace,treeitem FROM ##depTree; 
						DROP PROCEDURE ##getDependencyTree; 
						DROP TABLE ##depTree; 	
						SET NOCOUNT ON;
					</cfquery>
					
				</cftransaction>
				
				<cfcatch>
					<cfset getobject_depstree = querynew("nothing")>
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to render dependency tree: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
			
			</cfif>
			
			<cfif not isdefined("url.v") and (not isdefined("url.subframe") or url.subframe eq "top")>
			<cfif not issys>
			<cftry>
				<cfif val(hasFT)>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_fulltext">
						<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_help_fulltext_columns '#trim(url.oid)#';
					</cfquery>
				<cfelse>
					<cfset getobject_fulltext = querynew("nothing")>
				</cfif>	
					<cfcatch>
						<cfset getobject_fulltext = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get fulltext property data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>	
			</cfif>
			</cfif>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>
			
			<cfif isdefined("url.v")><!--- get schema for views --->
			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="tvschema">
					<cfif not isdefined("url.master")>
						EXEC sp_helptext '#trim(url.oid)#';
					<cfelse>
						USE master; EXEC sp_helptext '#trim(url.oid)#';
					</cfif>
				</cfquery>
			<cfcatch type="Any">
				<cfset tvschema = querynew("text")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>
			
			</cfif>
			
		</cfif>
		