
		<!--- for controlling fulltext focused details below --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="checkFT">
			SELECT hasFTinstalled = FULLTEXTSERVICEPROPERTY('IsFulltextInstalled')
		</cfquery>

		<cfset hasFT = checkFT.hasFTinstalled>
		
		<cfif isdefined("url.cfg")>
			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="config">
					SELECT 
					text1 = 'Number of opened or attempted connections', label1 = '@@CONNECTIONS', data1 = @@CONNECTIONS, 
					text2 = 'Current value of the SET DATEFIRST parameter', label2 = '@@DATEFIRST', data2 = CASE @@DATEFIRST WHEN 1 THEN 'Monday (1)' WHEN 2 THEN 'Tuesday (2)' WHEN 3 THEN 'Wednesday (3)' WHEN 4 THEN 'Thursday (4)' WHEN 5 THEN 'Friday (5)' WHEN 6 THEN 'Saturday (6)' ELSE 'Sunday (7)' END,  
					text3 = 'Name of the language currently in use', label3 = '@@LANGUAGE', data3 = @@LANGUAGE,
					text4 = 'ID of the language currently in use', label4 = '@@LANGID', data4 = @@LANGID, 
					text5 = 'Lock time-out setting for the current session', label5 = '@@LOCK_TIMEOUT', data5 = @@LOCK_TIMEOUT,
					text6 = 'Max number of simultaneous user connections', label6 = '@@MAX_CONNECTIONS', data6 = @@MAX_CONNECTIONS,
					text7 = 'Precision level used by decimal and numeric data types', label7 = '@@MAX_PRECISION', data7 = @@MAX_PRECISION, 
					text8 = 'Information about the current SET options', label8 = '@@OPTIONS', data8 = @@OPTIONS, 
					text9 = 'Name of the remote SQL Server database server', label9 = '@@REMSERVER', data9 = ISNULL(@@REMSERVER,'NULL'), 
					text10 = 'Name of the local server running SQL Server', label10 = '@@SERVERNAME', data10 = @@SERVERNAME, 
					text11 = 'Current value of the TEXTSIZE option', label11 = '@@TEXTSIZE', data11 = @@TEXTSIZE, 
					text12 = 'Date, version and cpu information for the current installation', label12 = '@@VERSION', data12 = @@VERSION, 
					text13 = 'The name of the default collation for the server', label13 = 'Collation', data13 = serverproperty('collation'),
					text14 = 'The edition of the SQL Server instance installed on the server', label14 = 'Edition', data14 = serverproperty('edition'),
					text15 = 'The engine edition of the SQL Server instance installed on the server', label15 = 'Engine Edition', data15 = CASE CAST(serverproperty('engine edition') AS int) WHEN 1 THEN 'Personal or Desktop Engine (1)' WHEN 2 THEN 'Standard (2)' WHEN 3 THEN 'Enterprise (3)' ELSE 'Unknown (' + ISNULL(CAST(serverproperty('engine edition') AS nvarchar),'NULL') + ')' END,
					text16 = 'The name of the instance to which connection is established', label16 = 'Instancename', data16 = ISNULL(serverproperty('instancename'),'NULL'),
					text17 = 'The server instance is configured in a failover cluster', label17 = 'IsClustered', data17 = CASE CAST(serverproperty('isclustered') AS int) WHEN 1 THEN 'Clustered' ELSE 'Not Clustered' END,
					text18 = 'The full-text component is installed with the current instance of SQL Server', label18 = 'IsFullTextInstalled', data18 = CASE CAST(serverproperty('isfulltextinstalled') AS int) WHEN 1 THEN 'Yes' ELSE 'No' END,
					text19 = 'The server is in integrated security mode', label19 = 'IsIntegratedSecurityOnly', data19 = CASE CAST(serverproperty('isintegratedsecurityonly') AS int) WHEN 1 THEN 'Yes' ELSE 'No' END,
					text20 = 'Windows NT computer name on which the server instance is running', label20 = 'MachineName', data20 = serverproperty('machinename'),
					text21 = 'The version of the instance of SQL Server, in the form of *major.minor.build*', label21 = 'ProductVersion', data21 = serverproperty('productversion'), 
					numValues = 21 
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset config = querynew("nothing")>
			</cfcatch>
			</cftry>

			<!--- JOB INFO --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="jobconfig">
					/*******************************************************************************
					
					Name:			GetJobSchedule	(For SQL Server7.0&2000)
					
					Author:			M.Pearson
					Modified By:		M.Austin, KjM 
					Creation Date:		5 Jun 2002
					Version:		1.0
					
					
					Program Overview:	This queries the sysjobs, sysjobschedules and sysjobhistory table to
								produce a resultset showing the jobs on a server plus their schedules
								(if applicable) and the maximun duration of the job.
								
								The UNION join is to cater for jobs that have been scheduled but not yet
								run, as this information is stored in the 'active_start...' fields of the 
								sysjobschedules table, whereas if the job has already run the schedule 
								information is stored in the 'next_run...' fields of the sysjobschedules table.
					
					
					Modification History:
					-------------------------------------------------------------------------------
					Version Date		Name		Modification
					-------------------------------------------------------------------------------
					1.0 	5  Jun 2002	M.Pearson	Inital Creation
					1.1	15 Dec 2003     M. Austin	Added How often it occurs on and at what interval
					1.2	16 Dec 2003	M. Austin	Added Last Duration and Last Run Status
					1.2	16 Dec 2003	M. Austin	Made it a Procedure
					1.21 15 Mar 2004 KjM Changed to a straight query from  proc for use in DBX
					1.22 4 Jul 2007 KjM Updated for SQL2K5 
					
					*******************************************************************************/

					USE [msdb] USE MSDB
					
					SELECT dbo.sysjobs.Name AS 'JobName', 
						'JobEnabled' = CASE dbo.sysjobs.Enabled
							WHEN 1 THEN 'Yes'
							WHEN 0 THEN 'No'
						END,
						'ScheduleEnabled' = NULL /* CASE dbo.sysschedules.Enabled
							WHEN 1 THEN 'Yes'
							WHEN 0 THEN 'No'
						END */,
						'Frequency' = CASE freq_type
							WHEN 1 THEN 'Once'
							WHEN 4 THEN 'Daily'
							WHEN 8 THEN 'Weekly'
							WHEN 16 THEN 'Monthly'
							WHEN 32 THEN 'Monthly relative'
							WHEN 64 THEN 'When SQLServer Agent starts'
						END, 
						'OccursEvery'=freq_subday_interval,
					'SubFreqInterval'=  Case  freq_subday_type 
										when 4 then 'Minutes' 
										When 8 then 'Hours'
									  End,
						'StartDate' = CASE active_start_date
							WHEN 0 THEN null
							ELSE
							substring(convert(varchar(15),active_start_date),1,4) + '/' + 
							substring(convert(varchar(15),active_start_date),5,2) + '/' + 
							substring(convert(varchar(15),active_start_date),7,2)
						END,
						'StartTime' = CASE len(active_start_time)
							WHEN 3 THEN cast('00:0' 
									+ Left(right(active_start_time,3),1)  
									+':' + right(active_start_time,2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(active_start_time,4),2)  
									+':' + right(active_start_time,2) as char (8))
							WHEN 5 THEN cast('0' 
									+ Left(right(active_start_time,5),1) 
									+':' + Left(right(active_start_time,4),2)  
									+':' + right(active_start_time,2) as char (8))
							WHEN 6 THEN cast(Left(right(active_start_time,6),2) 
									+':' + Left(right(active_start_time,4),2)  
									+':' + right(active_start_time,2) as char (8))
						END,
						isnull(CASE len(Q1.run_duration)
							WHEN 1 THEN cast('00:00:0'
									+ cast(Q1.run_duration as char) as char (8))
							WHEN 2 THEN cast('00:00:'
									+ cast(Q1.run_duration as char) as char (8))
							WHEN 3 THEN cast('00:0' 
									+ Left(right(Q1.run_duration,3),1)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 5 THEN cast('0' 
									+ Left(right(Q1.run_duration,5),1) 
									+':' + Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 6 THEN cast(Left(right(Q1.run_duration,6),2) 
									+':' + Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
						END,'NA') as 'MaxDuration',
							isnull(CASE len(Q2.[LastDuration])
							WHEN 1 THEN cast('00:00:0'
									+ cast(Q2.[LastDuration] as char) as char (8))
							WHEN 2 THEN cast('00:00:'
									+ cast(Q2.[LastDuration] as char) as char (8))
							WHEN 3 THEN cast('00:0' 
									+ Left(right(Q2.[LastDuration],3),1)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 5 THEN cast('0' 
									+ Left(right(Q2.[LastDuration],5),1) 
									+':' + Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 6 THEN cast(Left(right(Q2.[LastDuration],6),2) 
									+':' + Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
						END,'NA') as 'LastDuration',
					'LastRunStatus'=isnull(Case when Q2.run_status =1  then 'Succeeded' when Q2.run_status=0 then 'Failed' End,'NA')
					FROM dbo.sysjobs 
					LEFT OUTER JOIN dbo.sysjobschedules 
					ON dbo.sysjobs.job_id = dbo.sysjobschedules.job_id INNER JOIN dbo.sysschedules ON dbo.sysjobschedules.schedule_ID = dbo.sysschedules.schedule_ID 
					LEFT OUTER JOIN (SELECT job_id, max(run_duration) AS run_duration
							FROM dbo.sysjobhistory
							GROUP BY job_id) Q1
					ON dbo.sysjobs.job_id = Q1.job_id
					Left outer join (select T0.job_id,T0.run_status,'LastDuration'=T0.run_duration from sysjobhistory T0
					inner join 
					(select job_id,'Instance_id'=max(instance_id) FROM dbo.sysjobhistory where  step_id=1 GROUP BY job_id ) T1
					On
					T0.job_id=T1.job_id and
					T0.instance_id=T1.instance_id) Q2
					ON dbo.sysjobs.job_id = Q2.job_id
					WHERE Next_run_time = 0
					
					UNION
					
					SELECT dbo.sysjobs.Name AS 'JobName', 
						'Job Enabled' = CASE dbo.sysjobs.Enabled
							WHEN 1 THEN 'Yes'
							WHEN 0 THEN 'No'
						END,
						'ScheduleEnabled' = CASE dbo.sysschedules.Enabled
							WHEN 1 THEN 'Yes'
							WHEN 0 THEN 'No'
						END,
						'Frequency' = CASE freq_type
							WHEN 1 THEN 'Once'
							WHEN 4 THEN 'Daily'
							WHEN 8 THEN 'Weekly'
							WHEN 16 THEN 'Monthly'
							WHEN 32 THEN 'Monthly relative'
							WHEN 64 THEN 'When SQLServer Agent starts'
						END, 
						'OccursEvery'=freq_subday_interval,
						'SubFreqInterval'=  Case  freq_subday_type 
										when 4 then 'Minutes' 
										When 8 then 'Hours'
									  End,
						'StartDate' = CASE next_run_date
							WHEN 0 THEN null
							ELSE
							substring(convert(varchar(15),next_run_date),1,4) + '/' + 
							substring(convert(varchar(15),next_run_date),5,2) + '/' + 
							substring(convert(varchar(15),next_run_date),7,2)
						END,
						'StartTime' = isnull(CASE len(next_run_time)
							WHEN 3 THEN cast('00:0' 
									+ Left(right(next_run_time,3),1)  
									+':' + right(next_run_time,2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(next_run_time,4),2)  
									+':' + right(next_run_time,2) as char (8))
							WHEN 5 THEN cast('0' + Left(right(next_run_time,5),1) 
									+':' + Left(right(next_run_time,4),2)  
									+':' + right(next_run_time,2) as char (8))
							WHEN 6 THEN cast(Left(right(next_run_time,6),2) 
									+':' + Left(right(next_run_time,4),2)  
									+':' + right(next_run_time,2) as char (8))
						END,'NA'),
						isnull(CASE len(Q1.run_duration)
							WHEN 1 THEN cast('00:00:0'
									+ cast(Q1.run_duration as char) as char (8))
							WHEN 2 THEN cast('00:00:'
									+ cast(Q1.run_duration as char) as char (8))
							WHEN 3 THEN cast('00:0' 
									+ Left(right(Q1.run_duration,3),1)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 5 THEN cast('0' 
									+ Left(right(Q1.run_duration,5),1) 
									+':' + Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
							WHEN 6 THEN cast(Left(right(Q1.run_duration,6),2) 
									+':' + Left(right(Q1.run_duration,4),2)  
									+':' + right(Q1.run_duration,2) as char (8))
						END,'NA') as 'Max Duration',
						isnull(CASE len(Q2.[LastDuration])
							WHEN 1 THEN cast('00:00:0'
									+ cast(Q2.[LastDuration] as char) as char (8))
							WHEN 2 THEN cast('00:00:'
									+ cast(Q2.[LastDuration] as char) as char (8))
							WHEN 3 THEN cast('00:0' 
									+ Left(right(Q2.[LastDuration],3),1)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 4 THEN cast('00:' 
									+ Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 5 THEN cast('0' 
									+ Left(right(Q2.[LastDuration],5),1) 
									+':' + Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
							WHEN 6 THEN cast(Left(right(Q2.[LastDuration],6),2) 
									+':' + Left(right(Q2.[LastDuration],4),2)  
									+':' + right(Q2.[LastDuration],2) as char (8))
						END,'NA') as 'LastDuration',
					'LastRunStatus'=isnull(Case when Q2.run_status =1  then 'Succeeded' when Q2.run_status=0 then 'Failed' End,'NA')
					FROM dbo.sysjobs 
					LEFT OUTER JOIN dbo.sysjobschedules 
					ON dbo.sysjobs.job_id = dbo.sysjobschedules.job_id INNER JOIN dbo.sysschedules ON dbo.sysjobschedules.schedule_ID = dbo.sysschedules.schedule_ID 
					LEFT OUTER JOIN (SELECT job_id, max(run_duration) AS run_duration
							FROM dbo.sysjobhistory
							GROUP BY job_id) Q1
					ON dbo.sysjobs.job_id = Q1.job_id
					Left outer join (select T0.job_id,T0.run_status,'LastDuration'=T0.run_duration from sysjobhistory T0
					inner join 
					(select job_id,'Instance_id'=max(instance_id) FROM dbo.sysjobhistory where  step_id=1 GROUP BY job_id ) T1
					On
					T0.job_id=T1.job_id and
					T0.instance_id=T1.instance_id) Q2
					ON dbo.sysjobs.job_id = Q2.job_id
					WHERE Next_run_time <> 0
					
					ORDER BY [StartDate],[StartTime]
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset queryError = "#cfcatch.message# #cfcatch.detail#">
				<cfset jobconfig = querynew("nothing")>
			</cfcatch>
			</cftry>
		
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>
				
		<cfelseif isdefined("url.dbcfg")>
				

			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="fulltextconfig">
					SELECT [name], 
					populatestatus = CASE FULLTEXTCATALOGPROPERTY([name],'PopulateStatus') 
					WHEN 0 THEN 'Idle' WHEN 1 THEN 'Population in progress' WHEN 2 THEN 'Paused' 
					WHEN 3 THEN 'Throttled' WHEN 4 THEN 'Recovering' WHEN 5 THEN 'Shutdown' 
					WHEN 6 THEN 'Incremental Population in progress' WHEN 7 THEN 'Updating index' ELSE 'Unknown' END,
					FULLTEXTCATALOGPROPERTY([name],'ItemCount') AS itemcount,
					FULLTEXTCATALOGPROPERTY([name],'IndexSize') AS indexsize, 
					FULLTEXTCATALOGPROPERTY([name],'UniqueKeyCount') AS uniquekeycount, 
					FULLTEXTCATALOGPROPERTY([name],'LogSize') AS logsize,
					FULLTEXTCATALOGPROPERTY([name],'PopulateCompletionAge') AS populatecompletionage, 
					DATEDIFF(s,'01/01/1990',getdate()) AS agenow  
					FROM sysfulltextcatalogs	
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset fulltextconfig = querynew("nothing")>
			</cfcatch>
			</cftry>
			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="dbconfig">
					SELECT 
					databaseName = '#defaultdb.name#', 
					text1 = 'Database follows ANSI-92 standard for NULL values', label1 = 'IsAnsiNullDefault', data1 = CASE DATABASEPROPERTY('#defaultdb.name#','IsAnsiNullDefault') WHEN 0 THEN 'No' ELSE 'Yes' END,
					text2 = 'All comparisons made with a NULL cannot be evaluated', label2 = 'IsAnsiNullsEnabled', data2 = CASE DATABASEPROPERTY('#defaultdb.name#','') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text3 = 'Warning messages are issued when standard error conditions occur', label3 = 'IsAnsiWarningsEnabled', data3 = CASE DATABASEPROPERTY('#defaultdb.name#','IsAnsiWarningsEnabled') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text4 = 'Database frees resources after the last user has exited', label4 = 'IsAutoClose', data4 = CASE DATABASEPROPERTY('#defaultdb.name#','IsAutoClose') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text5 = 'Database files can be shrunk automatically and periodically', label5 = 'IsAutoShrink', data5 = CASE DATABASEPROPERTY('#defaultdb.name#','IsAutoShrink') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text6 = 'Autoupdate statistics option has been enabled', label6 = 'IsAutoUpdateStatistics', data6 = CASE DATABASEPROPERTY('#defaultdb.name#','IsAutoUpdateStatistics') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text7 = 'Database allows non-logged operations (e.g., bulk copy program)', label7 = 'IsBulkCopy', data7 = CASE DATABASEPROPERTY('#defaultdb.name#','IsBulkCopy') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text8 = 'Any cursors that are open when a transaction is committed will be closed', label8 = 'IsCloseCursorsOnCommitEnabled', data8 = CASE DATABASEPROPERTY('#defaultdb.name#','IsCloseCursorsOnCommitEnabled') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text9 = 'Database is only accessible by dbo', label9 = 'IsDboOnly', data9 = CASE DATABASEPROPERTY('#defaultdb.name#','IsDboOnly') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text10 = 'Cursor declarations default to LOCAL', label10 = 'IsLocalCursorsDefault', data10 = CASE DATABASEPROPERTY('#defaultdb.name#','IsLocalCursorsDefault') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text11 = 'Concatenating to a NULL results in a NULL', label11 = 'IsNullConcat', data11 = CASE DATABASEPROPERTY('#defaultdb.name#','IsNullConcat') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text12 = 'Identifiers can be delimited by double quotation marks', label12 = 'IsQuotedIdentifiersEnabled', data12 = CASE DATABASEPROPERTY('#defaultdb.name#','IsQuotedIdentifiersEnabled') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text13 = 'Database is in read-only mode', label13 = 'IsReadOnly', data13 = CASE DATABASEPROPERTY('#defaultdb.name#','IsReadOnly') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text14 = 'Recursive firing of triggers is enabled', label14 = 'IsRecursiveTriggersEnabled', data14 = CASE DATABASEPROPERTY('#defaultdb.name#','IsRecursiveTriggersEnabled') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text15 = 'The database truncates its log on checkpoints', label15 = 'IsTruncLog', data15 = CASE DATABASEPROPERTY('#defaultdb.name#','IsTruncLog') WHEN 0 THEN 'No' ELSE 'Yes' END, 
					text16 = 'Internal version number of the SQL Server code with which the database was created', label16 = 'Version', data16 = DATABASEPROPERTY('#defaultdb.name#','Version'), 
					text17 = 'Database has been full-text enabled', label17 = 'IsFullTextEnabled', data17 = CASE DATABASEPROPERTY('#defaultdb.name#','IsFullTextEnabled') WHEN 0 THEN 'No' ELSE 'Yes' END,
					text18 = 'Simple, Full, or Bulk-Logged', label18 = 'Recovery Model', data18 = DATABASEPROPERTYEX('#defaultdb.name#','Recovery'), 
					numValues = 18 
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset dbconfig = querynew("nothing")>
			</cfcatch>
			</cftry>
			
			<!--- table row counts --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="tablerowtotals">
					CREATE TABLE ##trt (
						tblName varchar(255), 
						rowTotal int, 
						reserved varchar(20), 
						data varchar(20), 
						index_size varchar(20),
						unused varchar(20) 
					); 

					EXEC sp_MSforeachtable @command1='INSERT ##trt EXEC sp_spaceused ''?''';
					
					SELECT * FROM ##trt ORDER BY tblName; 
					
					DROP TABLE ##trt; 
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset tablerowtotals = querynew("nothing")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>
			
			<!--- DB EXT PROPS --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_extprops">
					SELECT [name], value
					FROM fn_listextendedproperty(default, default, default, default, default, default, default) 
					ORDER BY [name]; 
				</cfquery>
				
				<cfcatch>
					<cfset getobject_extprops = querynew("nothing")>
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to get extended property data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>
			
		<cfelseif isdefined("url.sp")>
			
			<!--- PROC INFO --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
					<cfif not isdefined("url.master")>
						EXEC sp_sproc_columns '#trim(url.oid)#';
					<cfelse>
						USE master; EXEC sp_sproc_columns '#trim(url.oid)#','#trim(url.owid)#'; 
					</cfif>
				</cfquery>
			<cfcatch type="Any">
				<cfif not isdefined("url.subframe") or url.subframe eq "top">
					<cfhtmlhead text="<script>APP.writeErrors('#jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
				</cfif>
				<cfset getobject = querynew("nothing")>
			</cfcatch>
			</cftry>
			
			<!--- PROC EXT PROPS --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_extprops">
					SELECT objname,objtype,[name],value,pos = (CASE e.objtype WHEN 'procedure' THEN 1 WHEN 'function' THEN 1 WHEN 'parameter' THEN 2 ELSE 3 END) FROM (
					SELECT * FROM   fn_listextendedproperty (null, 'user', '#url.owid#', '<cfif not isdefined("url.fn")>procedure<cfelse>function</cfif>', '#trim(url.oid)#', null, null)
					UNION 
					SELECT * FROM   fn_listextendedproperty (null, 'user', '#url.owid#', '<cfif not isdefined("url.fn")>procedure<cfelse>function</cfif>', '#trim(url.oid)#', 'parameter', null) ) e 
					ORDER BY pos,objname,[name];
				</cfquery>
				
				<cfcatch>
					<cfset getobject_extprops = querynew("nothing")>
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to get extended property data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>

			<!--- PROC SCHEMA --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="spschema">
					<cfif not isdefined("url.master")>
						EXEC sp_helptext '#trim(url.oid)#';
					<cfelse>
						USE master; EXEC sp_helptext '#trim(url.oid)#'; 
					</cfif>
				</cfquery>
			<cfcatch type="Any">
				<cfset spschema = querynew("text")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>

			<!--- PROC DDL - same as above, will remove other in future release --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="spddl">
					<cfif isdefined("url.master")>USE MASTER; </cfif>SELECT text = OBJECT_DEFINITION(OBJECT_ID('#trim(url.oid)#')); 
				</cfquery>
			<cfcatch type="Any">
				<cfset spddl = querynew("text")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>

		<cfelseif isdefined("url.tr")>
			
			<!--- TRIGGER SCHEMA --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
					<cfif not isdefined("url.master")>
						SELECT c.text FROM dbo.sysobjects s,dbo.syscomments c 
						WHERE s.name = '#trim(url.oid)#' AND s.id = c.id 
					<cfelse>
						USE master; 
						SELECT c.text FROM dbo.sysobjects s,dbo.syscomments c 
						WHERE s.name = '#trim(url.oid)#' AND s.id = c.id 
					</cfif>
				</cfquery>
			<cfcatch type="Any">
				<cfset getobject = querynew("nothing")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>

			<!--- TRIGGER SCHEMA --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="trschema">
					<cfif not isdefined("url.master")>
						SELECT c.text FROM dbo.sysobjects s,dbo.syscomments c 
						WHERE s.name = '#trim(url.oid)#' AND s.id = c.id 
					<cfelse>
						USE master; 
						SELECT c.text FROM dbo.sysobjects s,dbo.syscomments c 
						WHERE s.name = '#trim(url.oid)#' AND s.id = c.id 
					</cfif>
				</cfquery>
			<cfcatch type="Any">
				<cfset trschema = querynew("text")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>

			<!--- TRIGGER DDL - same as above, will remove other in future release  --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="trddl">
					<cfif isdefined("url.master")>USE MASTER; </cfif>SELECT text = OBJECT_DEFINITION(OBJECT_ID('#trim(url.oid)#')); 
				</cfquery>
			<cfcatch type="Any">
				<cfset trddl = querynew("text")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>
					
		<cfelse>
		
			<!--- TABLE/VIEW INFO --->
			<cftry>

				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
					<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_columns '#trim(url.oid)#';
				</cfquery>

				<!--- compensate for crappy handling of (n)varchar(max) datatypes --->
				<cfloop query="getobject">
					<cfif getobject.DATA_TYPE eq -1>

						<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getupdateobject">
							<cfif isdefined("url.master")>USE master; </cfif>
							SELECT   
								c.DATA_TYPE,  
								c.CHARACTER_MAXIMUM_LENGTH 
							FROM INFORMATION_SCHEMA.COLUMNS c
								JOIN sys.columns sc ON c.TABLE_NAME = OBJECT_NAME(sc.object_id) AND c.COLUMN_NAME = sc.Name 
								JOIN sys.types st ON COALESCE(c.DOMAIN_NAME,c.DATA_TYPE) = st.name
								LEFT OUTER JOIN sys.objects dobj ON dobj.object_id = sc.default_object_id AND dobj.type = 'D' 
							WHERE c.TABLE_NAME = <cfqueryparam cfsqltype="cf_sql_varchar" value="#trim(url.oid)#" null="false"> 
								AND c.COLUMN_NAME = <cfqueryparam cfsqltype="cf_sql_varchar" value="#trim(getobject.COLUMN_NAME)#" null="false"> 
						</cfquery>

						<cfif getupdateobject.recordcount>
							<cfset querysetcell(getobject,"TYPE_NAME",getupdateobject.DATA_TYPE,getobject.currentrow)>
							<cfset querysetcell(getobject,"LENGTH",getupdateobject.CHARACTER_MAXIMUM_LENGTH,getobject.currentrow)>
							<!--- <cfif listfindnocase("varchar,nvarchar",getupdateobject.DATA_TYPE)>
								<cfset querysetcell(getobject,"PRECISION","max",getobject.currentrow)>
							</cfif> --->
						</cfif>

					</cfif> 
				</cfloop>
				
				<cfset theTableOwner = getobject.table_owner[1]>
				
				<cfcatch>
					<cfset getobject = querynew("nothing")>
					<cfset theTableOwner = "">
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to get object data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
			
			<cfif not isdefined("url.v")>
			
				<!--- TABLE/COL EXT PROPS --->				
				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_extprops">
						SELECT objname,objtype,[name],value,pos = (CASE e.objtype WHEN 'table' THEN 1 WHEN 'column' THEN 2 ELSE 3 END) FROM (
						SELECT * FROM   fn_listextendedproperty (null, 'user', '#theTableOwner#', 'table', '#trim(url.oid)#', null, null)
						UNION 
						SELECT * FROM   fn_listextendedproperty (null, 'user', '#theTableOwner#', 'table', '#trim(url.oid)#', 'column', null) ) e 
						ORDER BY pos,objname,[name];
					</cfquery>
					
					<!--- improve column sorting --->
					<cfset goextarray = arraynew(1)>
					<cfloop query="getobject_extprops">
						<cfif objtype neq "column">
							<cfset arrayappend(goextarray,'000')>
						<cfelse>
							<cfset goextpos = listfindnocase(valuelist(getobject.column_name),objname)>
							<cfif goextpos>
								<cfset arrayappend(goextarray,right('000' & listgetat(valuelist(getobject.ordinal_position),goextpos),3))>
							</cfif>
						</cfif>
					</cfloop>
					
					<cfset queryaddcolumn(getobject_extprops,"finalpos","varchar",goextarray)><!--- apparently doing a subsequent query of queries and sorting on the new int doesn't treat it like a freaking number --->
					
					<cfquery dbtype="query" name="getobject_extprops">
						SELECT * FROM getobject_extprops 
						ORDER BY pos,finalpos,objname,[name]
					</cfquery>
					
					<cfcatch>
						<cfset getobject_extprops = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get extended property data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>
			
			<cfelse>
			
				<!--- VIEW/COL EXT PROPS --->
				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_extprops">
						SELECT objname,objtype,[name],value,pos = (CASE e.objtype WHEN 'view' THEN 1 WHEN 'column' THEN 2 ELSE 3 END) FROM (
						SELECT * FROM  fn_listextendedproperty (null, 'user', '#theTableOwner#', 'view', '#trim(url.oid)#', null, null)
						UNION 
						SELECT * FROM   fn_listextendedproperty (null, 'user', '#theTableOwner#', 'view', '#trim(url.oid)#', 'column', null) ) e 
						ORDER BY pos,objname,[name];
					</cfquery>
										
					<!--- improve column sorting --->
					<cfset goextarray = arraynew(1)>
					<cfloop query="getobject_extprops">
						<cfif objtype neq "column">
							<cfset arrayappend(goextarray,'000')>
						<cfelse>
							<cfset goextpos = listfindnocase(valuelist(getobject.column_name),objname)>
							<cfif goextpos>
								<cfset arrayappend(goextarray,right('000' & listgetat(valuelist(getobject.ordinal_position),goextpos),3))>
							</cfif>
						</cfif>
					</cfloop>
					
					<cfset queryaddcolumn(getobject_extprops,"finalpos","varchar",goextarray)><!--- apparently doing a subsequent query of queries and sorting on the new int doesn't treat it like a freaking number --->
					
					<cfquery dbtype="query" name="getobject_extprops">
						SELECT * FROM getobject_extprops 
						ORDER BY pos,finalpos,objname,[name]
					</cfquery>
					
					<cfcatch>
						<cfset getobject_extprops = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get extended property data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>
			
			</cfif>
			
			<cfif not isdefined("url.v") and (not isdefined("url.subframe") or url.subframe eq "top")>
				<cftry>
					
					<!--- TABLE KEYS --->
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_keys">
						<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_MStablekeys '<cfif url.owid eq "sys">sys.</cfif>#trim(url.oid)#';
					</cfquery>
					
					<cfcatch>
						<cfset getobject_keys = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get object key data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>
				
				<cftry>
					
					<!--- TABLE INDEXES --->
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_indexes">
						<cfif isdefined("url.master")>USE master; </cfif><!---EXEC sp_helpindex '<cfif url.owid eq "sys">sys.</cfif>#trim(url.oid)#';--->
						<!--- dbx author note: i've included the following script pretty much intact, but have commented out
							any code related to it being installed as a stored proc - 2/26/2011 --->
						<!---
						/*============================================================================
						  File:     sp_helpindex2.sql
						
						  Summary:  So, what are the included columns?!
									This is a MODIFIED sp_helpindex script that includes INCLUDEd
									columns AND filtered index columns.
						  
						  Date:     August 2008
						
						  SQL Server *2008* Version: 10.00.1600.22 (SQL Server 2008 RTM)
						------------------------------------------------------------------------------
						  Written by Kimberly L. Tripp, SYSolutions, Inc.
						
						  For more scripts and sample code, check out 
						    http://www.SQLskills.com
						
						  This script is intended only as a supplement to demos and lectures
						  given by SQLskills instructors.  
						  
						  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
						  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
						  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
						  PARTICULAR PURPOSE.
						============================================================================*/
						
						USE master
						go
						
						create procedure sp_helpindex2
							@objname nvarchar(776)		-- the table to check for indexes
						as
						--->
						-- April 2008: Updated to add included columns to the output. 
						
						-- August 2008: Fixed a bug (missing begin/end block) AND I found
						-- a few other issues that people hadn't noticed (yikes!)!
						
						-- See Kimberly's blog for updates and/or additional information
						-- http://www.SQLskills.com/blogs/Kimberly
						
						-- safety check just in case the previous script bailed unexpectedly and left temp tables we want to try to get rid of
						IF OBJECT_ID('##spindtab') IS NOT NULL DROP TABLE ##spindtab;
						IF OBJECT_ID('##IncludedColumns') IS NOT NULL DROP TABLE ##IncludedColumns;
						
							-- PRELIM
							set nocount on
							declare @objname nvarchar(776); 
							set @objname = '<cfif url.owid eq "sys">sys.</cfif>#trim(url.oid)#'; 
							
							declare @objid int,			-- the object id of the table
									@indid smallint,	-- the index id of an index
									@groupid int,  		-- the filegroup id of an index
									@indname sysname,
									@groupname sysname,
									@status int,
									@keys nvarchar(2126),	--Length (16*max_identifierLength)+(15*2)+(16*3)
									@inc_columns	nvarchar(max),
									@inc_Count		smallint,
									@loop_inc_Count		smallint,
									@dbname	sysname,
									@ignore_dup_key	bit,
									@is_unique		bit,
									@is_hypothetical	bit,
									@is_primary_key	bit,
									@is_unique_key 	bit,
									@auto_created	bit,
									@no_recompute	bit,
									@filter_definition	nvarchar(max)
						
							-- Check to see that the object names are local to the current database.
							select @dbname = parsename(@objname,3)
							if @dbname is null
								select @dbname = db_name()
							else if @dbname <> db_name()
								begin
									raiserror(15250,-1,-1)
									-- return (1)
								end
						
							-- Check to see the the table exists and initialize @objid.
							select @objid = object_id(@objname)
							if @objid is NULL
							begin
								raiserror(15009,-1,-1,@objname,@dbname)
								-- return (1)
							end
						
							-- OPEN CURSOR OVER INDEXES (skip stats: bug shiloh_51196)
							declare ms_crs_ind cursor local static for
								select i.index_id, i.data_space_id, i.name,
									i.ignore_dup_key, i.is_unique, i.is_hypothetical, i.is_primary_key, i.is_unique_constraint,
									s.auto_created, s.no_recompute, i.filter_definition
								from sys.indexes i join sys.stats s
									on i.object_id = s.object_id and i.index_id = s.stats_id
								where i.object_id = @objid
							open ms_crs_ind
							fetch ms_crs_ind into @indid, @groupid, @indname, @ignore_dup_key, @is_unique, @is_hypothetical,
									@is_primary_key, @is_unique_key, @auto_created, @no_recompute, @filter_definition
						
							-- IF NO INDEX, QUIT
							if @@fetch_status < 0
							begin
								deallocate ms_crs_ind
								raiserror(15472,-1,-1,@objname) -- Object does not have any indexes.
								-- return (0)
							end
						
							-- create temp tables
							CREATE TABLE ##spindtab
							(
								index_name			sysname	collate database_default NOT NULL,
								index_id			int,
								ignore_dup_key		bit,
								is_unique			bit,
								is_hypothetical		bit,
								is_primary_key		bit,
								is_unique_key		bit,
								auto_created		bit,
								no_recompute		bit,
								groupname			sysname collate database_default NULL,
								index_keys			nvarchar(2126)	collate database_default NOT NULL, -- see @keys above for length descr
								filter_definition	nvarchar(max),
								inc_Count			smallint,
								inc_columns			nvarchar(max)
							)
						
							CREATE TABLE ##IncludedColumns
							(	RowNumber	smallint,
								[Name]	nvarchar(128)
							)
						
							-- Now check out each index, figure out its type and keys and
							--	save the info in a temporary table that we'll print out at the end.
							while @@fetch_status >= 0
							begin
								-- First we'll figure out what the keys are.
								declare @i int, @thiskey nvarchar(131) -- 128+3
						
								select @keys = index_col(@objname, @indid, 1), @i = 2
								if (indexkey_property(@objid, @indid, 1, 'isdescending') = 1)
									select @keys = @keys  + '(-)'
						
								select @thiskey = index_col(@objname, @indid, @i)
								if ((@thiskey is not null) and (indexkey_property(@objid, @indid, @i, 'isdescending') = 1))
									select @thiskey = @thiskey + '(-)'
						
								while (@thiskey is not null )
								begin
									select @keys = @keys + ', ' + @thiskey, @i = @i + 1
									select @thiskey = index_col(@objname, @indid, @i)
									if ((@thiskey is not null) and (indexkey_property(@objid, @indid, @i, 'isdescending') = 1))
										select @thiskey = @thiskey + '(-)'
								end
						
								-- Second, we'll figure out what the included columns are.
								SELECT @inc_Count = count(*)
								FROM sys.tables AS tbl
									INNER JOIN sys.indexes AS si ON (si.index_id > 0 AND si.is_hypothetical = 0) AND (si.object_id=tbl.object_id)
									INNER JOIN sys.index_columns AS ic 
										ON (ic.column_id > 0 AND (ic.key_ordinal > 0 OR ic.partition_ordinal = 0 OR ic.is_included_column != 0)) 
										AND (ic.index_id=CAST(si.index_id AS int) AND ic.object_id=si.object_id)
									INNER JOIN sys.columns AS clmns ON clmns.object_id = ic.object_id AND clmns.column_id = ic.column_id
								WHERE ic.is_included_column = 1 
									AND (si.index_id = @indid) 
									AND (tbl.object_id = @objid)
						
								IF @inc_Count > 0
								BEGIN
									DELETE FROM ##IncludedColumns
									INSERT ##IncludedColumns
									SELECT ROW_NUMBER() OVER (ORDER BY clmns.column_id), clmns.name 
									FROM sys.tables AS tbl
										INNER JOIN sys.indexes AS si ON (si.index_id > 0 AND si.is_hypothetical = 0) AND (si.object_id=tbl.object_id)
										INNER JOIN sys.index_columns AS ic 
											ON (ic.column_id > 0 AND (ic.key_ordinal > 0 OR ic.partition_ordinal = 0 OR ic.is_included_column != 0)) 
											AND (ic.index_id=CAST(si.index_id AS int) AND ic.object_id=si.object_id)
										INNER JOIN sys.columns AS clmns ON clmns.object_id = ic.object_id AND clmns.column_id = ic.column_id
									WHERE ic.is_included_column = 1 
										AND (si.index_id = @indid) 
										AND (tbl.object_id= @objid)
									
									SELECT @inc_columns = [Name] FROM ##IncludedColumns WHERE RowNumber = 1
						
									SET @loop_inc_Count = 1
						
									WHILE @loop_inc_Count < @inc_Count
									BEGIN
										SELECT @inc_columns = @inc_columns + ', ' + [Name] 
											FROM ##IncludedColumns WHERE RowNumber = @loop_inc_Count + 1
										SET @loop_inc_Count = @loop_inc_Count + 1
									END
								END
							
								select @groupname = null
								select @groupname = name from sys.data_spaces where data_space_id = @groupid
						
								-- INSERT ROW FOR INDEX
								insert into ##spindtab (index_name, index_id, ignore_dup_key, is_unique, is_hypothetical, is_primary_key, is_unique_key, auto_created, no_recompute, groupname, index_keys, filter_definition, inc_Count, inc_columns)
								values (@indname, @indid, @ignore_dup_key, @is_unique, @is_hypothetical,
									@is_primary_key, @is_unique_key, @auto_created, @no_recompute, @groupname, @keys, @filter_definition, @inc_Count, @inc_columns)

								SET @inc_columns = '';
								
								-- Next index
								fetch ms_crs_ind into @indid, @groupid, @indname, @ignore_dup_key, @is_unique, @is_hypothetical,
									@is_primary_key, @is_unique_key, @auto_created, @no_recompute, @filter_definition
							end
							deallocate ms_crs_ind
						
							-- DISPLAY THE RESULTS
							select
								'index_name' = index_name,
								'index_description' = convert(varchar(210), --bits 16 off, 1, 2, 16777216 on, located on group
										case when index_id = 1 then 'clustered' else 'nonclustered' end
										+ case when ignore_dup_key <>0 then ', ignore duplicate keys' else '' end
										+ case when is_unique <>0 then ', unique' else '' end
										+ case when is_hypothetical <>0 then ', hypothetical' else '' end
										+ case when is_primary_key <>0 then ', primary key' else '' end
										+ case when is_unique_key <>0 then ', unique key' else '' end
										+ case when auto_created <>0 then ', auto create' else '' end
										+ case when no_recompute <>0 then ', stats no recompute' else '' end
										+ ' located on ' + groupname),
								'index_keys' = index_keys,
								--'num_included_columns' = inc_Count,
								'included_columns' = inc_columns,
								'filter_definition' = filter_definition, 
								'is_primary_key' = is_primary_key 
							from ##spindtab
							order by index_name
						
							-- return (0) -- sp_helpindexwinc2
						<!---go
						
						exec sys.sp_MS_marksystemobject 'sp_helpindex2'
						--->
						DROP TABLE ##IncludedColumns; 
						DROP TABLE ##spindtab; 
					</cfquery>
					
					<cfif not isdefined("getobject_indexes")><!--- this can occur if the table is not indexed or the user doesn't have permissions --->
						<cfset getobject_indexes = querynew("index_name,index_keys,included_columns,index_description,is_primary_key")>
					</cfif>
					
					<cfcatch>
						<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="cleanup">
							IF OBJECT_ID('##spindtab') IS NOT NULL DROP TABLE ##spindtab;
							IF OBJECT_ID('##IncludedColumns') IS NOT NULL DROP TABLE ##IncludedColumns;
						</cfquery>
						<cfset getobject_indexes = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get object index data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>
				
				<!--- COL REFERENCES --->
				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_refs">
						<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_MStablerefs '<cfif url.owid eq "sys">sys.</cfif>#trim(url.oid)#';
					</cfquery>
					
					<cfcatch>
						<cfset getobject_refs = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get object reference data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>
			
				<!--- SPACE USAGE --->
				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_space">
						<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_MStablespace '<cfif url.owid eq "sys">sys.</cfif>#trim(url.oid)#';
					</cfquery>
					
					<cfcatch>
						<cfset getobject_space = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get object space data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>	

				<!--- TRIGGERS --->
				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_triggers">
						<cfif isdefined("url.master")>USE master; </cfif>
						SELECT s.name,c.text 
						FROM sysobjects s, syscomments c
						WHERE s.id = c.id AND s.parent_obj = (SELECT s2.id FROM sysobjects s2 WHERE s2.id = object_id('#trim(url.oid)#')) AND s.type = 'TR'			
					</cfquery>
					
					<cfcatch>
						<cfset getobject_space = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get object trigger data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>	

				<!--- TABLE DDL  --->
				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="tvddl">
						<cfif isdefined("url.master")>USE MASTER; </cfif>
						/* 
							this script is a modification of a stored proc by Tim Chapman on TechRepublic 'Script Table definitions using TSQL'
							modified 10/12/2008 kjm
						 */
     					DECLARE @TableName sysname, @IncludeConstraints bit, @IncludeIndexes bit, @newTableName sysname, @UseSystemDataTypes bit; 
						SET @TableName = '#trim(url.oid)#'; 
						SET @IncludeIndexes = 1;
						SET @IncludeConstraints = 1; 
						SET @NewTableName = NULL;
						SET @UseSystemDataTypes = 0; 
	 			
					     DECLARE @MainDefinition TABLE ( FieldValue VARCHAR(8000) ); 
					
					     DECLARE @DBName SYSNAME; 
					     DECLARE @ClusteredPK BIT; 
					     DECLARE @TableSchema NVARCHAR(255); 
					     SET @DBName = DB_NAME(DB_ID()); 
					
					     SELECT @TableName = name FROM sysobjects WHERE id = OBJECT_ID(@TableName); 
					
					     DECLARE @ShowFields TABLE (
					         FieldID INT IDENTITY(1,1),
					         DatabaseName VARCHAR(100),
					         TableOwner VARCHAR(100),
					         TableName VARCHAR(100),
					         FieldName VARCHAR(100),
					         ColumnPosition INT,
					         ColumnDefaultValue VARCHAR(100),
					         ColumnDefaultName VARCHAR(100),
					         IsNullable BIT,
					         DataType VARCHAR(100),
					         MaxLength INT,
					         NumericPrecision INT,
					         NumericScale INT,
					         DomainName VARCHAR(100),
					         FieldListingName VARCHAR(110),
					         FieldDefinition CHAR(1),
					         IdentityColumn BIT,
					         IdentitySeed INT,
					         IdentityIncrement INT,
					         IsCharColumn BIT
					     );
					
					     DECLARE @HoldingArea TABLE (
					         FldID SMALLINT IDENTITY(1,1),
					         Flds VARCHAR(8000),
					         FldValue CHAR(1) DEFAULT(0)
					     );
					
					     DECLARE @PKObjectID TABLE ( ObjectID INT );
					
					     DECLARE @Uniques TABLE ( ObjectID INT );
					
					     DECLARE @HoldingAreaValues TABLE (
					         FldID SMALLINT IDENTITY(1,1),
					         Flds VARCHAR(4000),
					         FldValue CHAR(1) DEFAULT(0)
					     ); 
					
					     DECLARE @Definition TABLE (
					         DefinitionID SMALLINT IDENTITY(1,1),
					         FieldValue VARCHAR(8000)
					     ); 				
					
					    INSERT INTO @ShowFields (       
					         DatabaseName,
					         TableOwner,
					         TableName,
					         FieldName,
					         ColumnPosition,
					         ColumnDefaultValue,
					         ColumnDefaultName,
					         IsNullable,
					         DataType,
					         MaxLength,
					         NumericPrecision,
					         NumericScale,
					         DomainName,
					         FieldListingName,
					         FieldDefinition,
					         IdentityColumn,
					         IdentitySeed,
					         IdentityIncrement,
					         IsCharColumn
					     )					
					     SELECT
					         DB_NAME(),
					         TABLE_SCHEMA,
					         TABLE_NAME,
					         COLUMN_NAME,
					         CAST(ORDINAL_POSITION AS INT),
					         COLUMN_DEFAULT,
					         dobj.name AS ColumnDefaultName,
					         CASE WHEN c.IS_NULLABLE = 'YES' THEN 1 ELSE 0 END,
					         DATA_TYPE,
					         CAST(CHARACTER_MAXIMUM_LENGTH AS INT),
					         CAST(NUMERIC_PRECISION AS INT),
					         CAST(NUMERIC_SCALE AS INT),
					         DOMAIN_NAME,
					         COLUMN_NAME + ',',
					         '' AS FieldDefinition,
					         CASE WHEN ic.object_id IS NULL THEN 0 ELSE 1 END AS IdentityColumn,
					         CAST(ISNULL(ic.seed_value,0) AS INT) AS IdentitySeed,
					         CAST(ISNULL(ic.increment_value,0) AS INT) AS IdentityIncrement,
					         CASE WHEN st.collation_name IS NOT NULL THEN 1 ELSE 0 END AS IsCharColumn
					     FROM
					         INFORMATION_SCHEMA.COLUMNS c
					         JOIN sys.columns sc ON  c.TABLE_NAME = OBJECT_NAME(sc.object_id) AND c.COLUMN_NAME = sc.Name
					         LEFT JOIN sys.identity_columns ic ON c.TABLE_NAME = OBJECT_NAME(ic.object_id) AND c.COLUMN_NAME = ic.Name
					         JOIN sys.types st ON COALESCE(c.DOMAIN_NAME,c.DATA_TYPE) = st.name
					         LEFT OUTER JOIN sys.objects dobj ON dobj.object_id = sc.default_object_id AND dobj.type = 'D' 					
					     WHERE c.TABLE_NAME = @TableName
					     ORDER BY
					         c.TABLE_NAME, c.ORDINAL_POSITION; 
					
					     SELECT TOP 1 @TableSchema = TableOwner FROM @ShowFields; 
					
					     INSERT INTO @HoldingArea (Flds) VALUES('('); 
					
					     INSERT INTO @Definition(FieldValue)
					     VALUES('CREATE TABLE ' + CASE WHEN @NewTableName IS NOT NULL THEN @NewTableName ELSE @DBName + '.' + @TableSchema + '.' + @TableName END); 
					
					     INSERT INTO @Definition(FieldValue) VALUES(' ('); 
					
					     INSERT INTO @Definition(FieldValue)
					         SELECT
					                 CHAR(10) + CHAR(9) + FieldName + ' ' +
					                                     CASE
					                                         WHEN DomainName IS NOT NULL AND @UseSystemDataTypes = 0 THEN DomainName + CASE WHEN IsNullable = 1 THEN ' NULL ' ELSE ' NOT NULL ' END
					                                         ELSE lower(DataType) +
															 	CASE WHEN IsCharColumn = 1 THEN '(' + case when MaxLength >0 then CAST(MaxLength AS VARCHAR(10)) else 'MAX' end + ')' ELSE '' END + -- this mod handles varchar(max) datatypes
					                                            -- CASE WHEN IsCharColumn = 1 THEN '(' + CAST(MaxLength AS VARCHAR(10)) + ')' ELSE '' END +
					                                             CASE WHEN IdentityColumn = 1 THEN ' identity(' + CAST(IdentitySeed AS VARCHAR(5))+ ',' + CAST(IdentityIncrement AS VARCHAR(5)) + ')' ELSE '' END +
					                                             CASE WHEN IsNullable = 1 THEN ' NULL ' ELSE ' NOT NULL ' END +
					                                             CASE WHEN ColumnDefaultName IS NOT NULL AND @IncludeConstraints = 1 THEN 'CONSTRAINT [' + ColumnDefaultName + '] DEFAULT' + UPPER(ColumnDefaultValue) ELSE '' END
					                                     END + CASE WHEN FieldID = (SELECT MAX(FieldID) FROM @ShowFields) THEN '' ELSE ',' END
					         FROM @ShowFields; 
					
					         IF @IncludeConstraints = 1
					         BEGIN
					             INSERT INTO @Definition(FieldValue) 				
					             SELECT ',' + CHAR(10) + CHAR(9) + 'CONSTRAINT [' + name + '] FOREIGN KEY (' + ParentColumns + ') REFERENCES [' + ReferencedObject + '](' + ReferencedColumns + ')'
					             FROM (
					                 SELECT
					                 ReferencedObject = OBJECT_NAME(fk.referenced_object_id), ParentObject = OBJECT_NAME(parent_object_id),fk.name,
					                 REVERSE(SUBSTRING(REVERSE((
					                 SELECT cp.name + ','
					                 FROM
					                 sys.foreign_key_columns fkc
					                 JOIN sys.columns cp ON fkc.parent_object_id = cp.object_id AND fkc.parent_column_id = cp.column_id
					                 WHERE fkc.constraint_object_id = fk.object_id
					                 FOR XML PATH('')
					                 )), 2, 8000)) ParentColumns,
					                 REVERSE(SUBSTRING(REVERSE((
					                 SELECT cr.name + ','
					                 FROM
					                 sys.foreign_key_columns fkc
					                 JOIN sys.columns cr ON fkc.referenced_object_id = cr.object_id AND fkc.referenced_column_id = cr.column_id
					                 WHERE fkc.constraint_object_id = fk.object_id
					                 FOR XML PATH('')
					                 )), 2, 8000)) ReferencedColumns
					                 FROM sys.foreign_keys fk
					             ) a
					             WHERE ParentObject = @TableName; 
					
					             INSERT INTO @Definition(FieldValue)
					             SELECT ',' + CHAR(10) + CHAR(9) + 'CONSTRAINT [' + name + '] CHECK ' + definition FROM sys.check_constraints
					             WHERE OBJECT_NAME(parent_object_id) = @TableName; 
					
					         INSERT INTO @PKObjectID(ObjectID)
					         SELECT DISTINCT
					             PKObject = cco.object_id
					         FROM
					             sys.key_constraints cco
					             JOIN sys.index_columns cc ON cco.parent_object_id = cc.object_id AND cco.unique_index_id = cc.index_id
					             JOIN sys.indexes i ON cc.object_id = i.object_id AND cc.index_id = i.index_id
					         WHERE
					             OBJECT_NAME(parent_object_id) = @TableName    AND   
					             i.type = 1 AND
					             is_primary_key = 1; 
					
					         INSERT INTO @Uniques(ObjectID)
					         SELECT DISTINCT
					             PKObject = cco.object_id
					         FROM
					             sys.key_constraints cco
					             JOIN sys.index_columns cc ON cco.parent_object_id = cc.object_id AND cco.unique_index_id = cc.index_id
					             JOIN sys.indexes i ON cc.object_id = i.object_id AND cc.index_id = i.index_id
					         WHERE
					             OBJECT_NAME(parent_object_id) = @TableName AND       
					             i.type = 2 AND
					             is_primary_key = 0 AND
					             is_unique_constraint = 1; 
					
					         SET @ClusteredPK = CASE WHEN @@ROWCOUNT > 0 THEN 1 ELSE 0 END; 
					
					         INSERT INTO @Definition(FieldValue)
					         SELECT    ',' + CHAR(10) + CHAR(9) + 'CONSTRAINT [' + name + ']' + CASE type WHEN 'PK' THEN ' PRIMARY KEY ' + CASE WHEN pk.ObjectID IS NULL THEN ' NONCLUSTERED ' ELSE ' CLUSTERED ' END
					                             WHEN 'UQ' THEN ' UNIQUE ' END + CASE WHEN u.ObjectID IS NOT NULL THEN ' NONCLUSTERED ' ELSE '' END + '(' +
					         REVERSE(SUBSTRING(REVERSE((
					             SELECT
					                 c.name +  + CASE WHEN cc.is_descending_key = 1 THEN ' DESC' ELSE ' ASC' END + ','
					             FROM
					                 sys.key_constraints ccok
					                 LEFT JOIN sys.index_columns cc ON ccok.parent_object_id = cc.object_id AND cco.unique_index_id = cc.index_id 					
					                 LEFT JOIN sys.columns c ON cc.object_id = c.object_id AND cc.column_id = c.column_id
					                 LEFT JOIN sys.indexes i ON cc.object_id = i.object_id AND cc.index_id = i.index_id
					             WHERE
					                 i.object_id = ccok.parent_object_id AND
					                 ccok.object_id = cco.object_id
					             FOR XML PATH('')
					         )), 2, 8000)) + ')'
					         FROM
					             sys.key_constraints cco
					             LEFT JOIN @PKObjectID pk ON cco.object_id = pk.ObjectID
					             LEFT JOIN @Uniques u ON cco.object_id = u.objectID
					         WHERE
					             OBJECT_NAME(cco.parent_object_id) = @TableName
					         END; 
					
					         INSERT INTO @Definition(FieldValue) VALUES(CHAR(10) + '); ' + CHAR(10)); 
					
					         IF @IncludeIndexes = 1
					         BEGIN
					             INSERT INTO @Definition(FieldValue)
					             SELECT
					                 'CREATE ' + type_desc + ' INDEX [' + [name] COLLATE SQL_Latin1_General_CP1_CI_AS + '] ON [' +  OBJECT_NAME(object_id) + '] (' +
					                 REVERSE(SUBSTRING(REVERSE((
					                     SELECT name + CASE WHEN sc.is_descending_key = 1 THEN ' DESC' ELSE ' ASC' END + ','
					                     FROM
					                         sys.index_columns sc
					                         JOIN sys.columns c ON sc.object_id = c.object_id AND sc.column_id = c.column_id
					                     WHERE
					                         OBJECT_NAME(sc.object_id) = @TableName AND
					                         sc.object_id = i.object_id AND
					                         sc.index_id = i.index_id
					                     ORDER BY index_column_id ASC
					                     FOR XML PATH('')
					             )), 2, 8000)) + '); ' + CHAR(10)
					             FROM sys.indexes i
					             WHERE
					                 OBJECT_NAME(object_id) = @TableName 				
					               	 AND CASE WHEN @ClusteredPK = 1 AND is_primary_key = 1 AND type = 1 THEN 0 ELSE 1 END = 1
					                 AND is_unique_constraint = 0
					                 AND is_primary_key = 0
					         END
					             INSERT INTO @MainDefinition(FieldValue)
					             SELECT FieldValue FROM @Definition
					             ORDER BY DefinitionID ASC
					
					         SELECT * FROM @MainDefinition
					</cfquery>
				<cfcatch type="Any">
					<cfset tvddl = querynew("text")>
				</cfcatch>
				</cftry>
				
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
					USE [#defaultdb.name#]; SELECT 1 AS blah; 
				</cfquery>
				
			</cfif>
			
			<!--- OBJECT DEPENDENCIES --->
			<cftry>			
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_deps">
					<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_MSdependencies '<cfif url.owid eq "sys">sys.</cfif>#trim(url.oid)#';
				</cfquery>
				
				<cfcatch>
					<cfset getobject_deps = querynew("nothing")>
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to get object dependency data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
			
			<!--- COLUMN DEPENDENCIES --->
			<cftry>			
				<cfif getobject.recordcount>
				
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_coldeps">
						<cfif isdefined("url.master")>USE master; </cfif>						
						SELECT 
							sc.name AS colName, 
							OBJECT_NAME(sd.id) AS depObj,
							(SELECT ltrim(rtrim(xtype)) FROM sysobjects so WHERE so.id = sd.id) AS depObjType, 
							USER_NAME(OBJECTPROPERTY(so.id, 'OwnerID')) AS depObjOwner 
						FROM sysobjects so 
							INNER JOIN syscolumns sc ON so.id = sc.id 
							INNER JOIN sysdepends sd ON so.id = sd.depid and sc.colid = sd.depnumber
						WHERE so.id = OBJECT_ID('<cfif url.owid eq "sys">sys.</cfif>#trim(url.oid)#') 
						ORDER BY sc.name 
					</cfquery>
				
				</cfif>
				
				<cfcatch>
					<cfset getobject_coldeps = querynew("nothing")>
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to get column dependency data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
		
			<cfif val(dbx.dataSampleRows)>
				<!--- DATA SAMPLING --->
				<cftry>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_datasample">
						SELECT TOP #val(dbx.dataSampleRows)# * FROM #trim(url.oid)#;
					</cfquery>
					
					<cfcatch>
						<cfset getobject_datasample = querynew("nothing")>
					</cfcatch>
				</cftry>
			</cfif>
			
			<cfif not isdefined("url.v") and (not isdefined("url.subframe") or url.subframe eq "top")>
			
			<cftry>
			<cftransaction>
			
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="depstreeCleanUp">
					USE tempdb; 
					IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'##getDependencyTree') ) BEGIN 
						DROP PROCEDURE ##getDependencyTree 
					END
					IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'##depTree') ) BEGIN 
						DROP TABLE ##depTree 
					END
					USE [#defaultdb.name#]; SELECT 1 AS blah; 
					</cfquery>

					<!--- DEPENDENCY TREE --->
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_depstreestep1">
					<cfif isdefined("url.master")>USE master; </cfif>
					CREATE PROCEDURE ##getDependencyTree 
						  @table_name varchar(100) -- the procedure will try to find all the child tables for the table @table_name 
						, @space_len int = -4 output -- for printing position purpose

						AS 

						BEGIN -- sp
							DECLARE @table_owner varchar(100)
						    DECLARE @child varchar(100)
						    SET @space_len = @space_len + 4
						
						    IF @table_name IS NULL
						    BEGIN -- return
						        SET @space_len = @space_len - 4
						        RETURN
						    END -- return 

							SET @table_owner = (SELECT USER_NAME(OBJECTPROPERTY(id, 'OwnerID')) FROM sysobjects WHERE name = @table_name); 
							IF LEN(@table_owner) > 0
							BEGIN 
								SET @table_owner = @table_owner + '.'
							END 
						
						    IF NOT EXISTS (SELECT * FROM sysforeignkeys WHERE rkeyid = OBJECT_ID(@table_name) )
						    BEGIN -- leaf level
						        IF @space_len <= 0 
									INSERT INTO ##depTree (treeitem) VALUES (@table_owner + @table_name) 
						        ELSE 
									INSERT INTO ##depTree (treeitemspace,treeitem) VALUES (space(@space_len) + '|-- ',@table_owner + @table_name) 
						
						        SET @space_len = @space_len - 4
						        RETURN 
						    END -- leaf level
							
						    ELSE  -- the @table_name table exists
						    BEGIN -- else
						        IF @space_len <= 0 
								   INSERT INTO ##depTree (treeitem) VALUES (@table_owner + @table_name) 
						        ELSE 
									INSERT INTO ##depTree (treeitemspace,treeitem) VALUES (space(@space_len) + '|-- ',@table_owner + @table_name) 
						
						        IF EXISTS ( SELECT * FROM sysforeignkeys WHERE rkeyid = OBJECT_ID(@table_name) AND rkeyid = fkeyid) -- self referenced
						           INSERT INTO ##depTree (treeitemspace,treeitem) VALUES (space(@space_len) + '|-- ',@table_owner + @table_name) 
						
						        DECLARE curChild CURSOR LOCAL FOR 
						        SELECT OBJECT_NAME(fkeyid) AS child FROM sysforeignkeys
						        WHERE rkeyid = OBJECT_ID(@table_name) AND rkeyid <> fkeyid 
						
						        OPEN curChild
						        FETCH NEXT FROM curChild INTO @child
						        
						        WHILE @@fetch_status = 0
						         BEGIN  -- cursor loop
						             EXEC ##getDependencyTree @table_name = @child, @space_len = @space_len output 
						             FETCH NEXT FROM curChild INTO @child
						          END -- cursor loop
						
						           CLOSE curChild
						           DEALLOCATE curChild
						        END --else
						        SET @space_len = @space_len - 4
						        RETURN 
						END --sp 
					</cfquery>
					
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_depstree">
						SET NOCOUNT OFF;
						<cfif isdefined("url.master")>USE master; </cfif>
						CREATE TABLE ##depTree (treeitemspace varchar(100),treeitem varchar(255));
						EXEC ##getDependencyTree '#trim(url.oid)#'; 
						SELECT treeitemspace,treeitem FROM ##depTree; 
						DROP PROCEDURE ##getDependencyTree; 
						DROP TABLE ##depTree; 	
						SET NOCOUNT ON;
					</cfquery>
					
				</cftransaction>
				
				<cfcatch>
					<cfset getobject_depstree = querynew("nothing")>
					<cfif not isdefined("url.subframe") or url.subframe eq "top">
						<cfhtmlhead text="<script>APP.writeErrors('Unable to render dependency tree: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
					</cfif>
				</cfcatch>
			</cftry>
			
			</cfif>
			
			<cfif not isdefined("url.v") and (not isdefined("url.subframe") or url.subframe eq "top")>
			<cfif not issys>
			<cftry>
				<!--- FULLTEXT  --->
				<cfif val(hasFT)>
					<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_fulltext">
						<cfif isdefined("url.master")>USE master; </cfif>EXEC sp_help_fulltext_columns '#trim(url.oid)#';
					</cfquery>
				<cfelse>
					<cfset getobject_fulltext = querynew("nothing")>
				</cfif>	
					<cfcatch>
						<cfset getobject_fulltext = querynew("nothing")>
						<cfif not isdefined("url.subframe") or url.subframe eq "top">
							<cfhtmlhead text="<script>APP.writeErrors('Unable to get fulltext property data: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
						</cfif>
					</cfcatch>
				</cftry>	
			</cfif>
			</cfif>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>
			
			<cfif isdefined("url.v")><!--- get schema for views --->
			
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="tvschema">
					<cfif not isdefined("url.master")>
						EXEC sp_helptext '<cfif url.owid eq "sys">sys.</cfif>#trim(url.oid)#';
					<cfelse>
						USE master; EXEC sp_helptext '<cfif url.owid eq "sys">sys.</cfif>#trim(url.oid)#';
					</cfif>
				</cfquery>
			<cfcatch type="Any">
				<cfset tvschema = querynew("text")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>

			<!--- VIEW DDL - same as above, will remove other in future release  --->
			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="tvddl">
					<cfif isdefined("url.master")>USE MASTER; </cfif>SELECT FieldValue = OBJECT_DEFINITION(OBJECT_ID('#trim(url.oid)#')); 
				</cfquery>
			<cfcatch type="Any">
				<cfset tvddl = querynew("text")>
			</cfcatch>
			</cftry>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
				USE [#defaultdb.name#]; SELECT 1 AS blah; 
			</cfquery>
			
			</cfif>
			
		</cfif>
		