
	<span class="heavy label">INDEXES [USER TABLES] : <cfoutput>#dbdsn#</cfoutput></span>
	<br><br>
	<cfloop query="allobjects"><cfif not len(ssr) or findlist(ssr,name)>
	<cfif type eq "U" and status gte 0>
	
	<cfsetting enablecfoutputonly="yes">
		
		<!--- <cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="index_details">
			EXEC sp_helpindex '#trim(name)#';
		</cfquery> --->
		
		<cftry>

		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_indexes">
		SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
		SELECT 
			t.schemaname, 
			t.object_id, 
			t.objectname,
			t.index_id,  
			t.indexname, 
			t.type_desc, 
			t.fill_factor, 
			t.is_disabled, 
			t.columns, 
			t.includedColumns, 
			t.numindexes, 
			pt.avg_fragmentation_in_percent, 
			pt.fragment_count, 
			pt.page_count,
			t.rows AS record_count, 
			pt.alloc_unit_type_desc 
		FROM (
			SELECT  
			  SCHEMA_NAME(o.schema_id) AS SchemaName ,
			  i.object_id, 
			  o.name AS ObjectName ,
			  i.index_id, 
			  i.name AS IndexName ,
			  i.type_desc , 
			  i.fill_factor,
			  i.is_disabled, 
			  LEFT(list, ISNULL(splitter - 1, LEN(list))) AS Columns ,
			  SUBSTRING(list, indCol.splitter + 1, 100) AS includedColumns,   
			  COUNT(1) OVER ( PARTITION BY o.object_id ) AS numIndexes, 
			  p.rows 
			FROM    
			  sys.indexes i
			  	INNER JOIN sys.objects o ON i.object_id = o.object_id 
				INNER JOIN sys.partitions p ON p.object_id = i.object_id AND p.index_id = i.index_id 
			  CROSS APPLY ( 
			    SELECT    
			      NULLIF(CHARINDEX('|', indexCols.list), 0) as splitter, list
			    FROM (
			      SELECT CAST(
			        (SELECT 
			            CASE 
			              WHEN sc.is_included_column = 1 AND sc.ColPos = 1 THEN '|' 
			              ELSE '' 
			            END
			            + 
			            CASE
			              WHEN sc.ColPos > 1 THEN ', ' 
			              ELSE '' 
			            END 
			            + 
			            name 
			            FROM (
			              SELECT 
			                sc.is_included_column ,
			                index_column_id ,
			                name ,
			                ROW_NUMBER() OVER ( PARTITION BY sc.is_included_column ORDER BY sc.index_column_id ) AS ColPos
			              FROM sys.index_columns sc 
			                JOIN sys.columns c ON sc.object_id = c.object_id AND sc.column_id = c.column_id
			              WHERE sc.index_id = i.index_id AND sc.object_id = i.object_id 
			            ) sc 
			        ORDER BY sc.is_included_column , ColPos
			        FOR XML PATH('') , TYPE
			      ) AS VARCHAR(MAX)) list
			    ) indexCols
			  ) indCol 
			WHERE o.name = <cfqueryparam cfsqltype="cf_sql_varchar" value="#name#" null="false">
				AND i.type_desc <> 'heap' 
				AND OBJECT_SCHEMA_NAME(p.object_id) != 'sys'
			) t 
			INNER JOIN sys.dm_db_index_physical_stats (DB_ID(), <cfqueryparam cfsqltype="cf_sql_integer" value="#object_id#" null="false">, NULL, NULL, 'limited') pt ON t.object_id = pt.object_id AND t.index_id = pt.index_id 
			ORDER BY SchemaName , type_desc, IndexName;
		</cfquery>

		<cfcatch>
			<cfdump var="#cfcatch#">
			<cfabort>
		</cfcatch>

		</cftry>

		<!--- SELECT 
				so.name AS tableName, 
				si.name AS indexName, 
				si.rows, 
				sc.name AS colName, 
				sik.indid,
				sik.keyno 
			FROM 
				sys.sysobjects so
				INNER JOIN sys.sysindexes si ON so.id = si.id 
				INNER JOIN sys.sysindexkeys sik ON so.id = sik.id 
				INNER JOIN sys.syscolumns sc ON so.id = sc.id AND sik.colid = sc.colid AND sik.indid = si.indid 
			WHERE so.name = '#name#' 
				AND so.type = 'U'  
				AND si.name NOT LIKE '_wa_sys%'
				AND si.impid <> -1 
			ORDER BY so.name, sc.colorder, sik.indid, si.name, sik.keyno  --->
		
	<cfsetting enablecfoutputonly="no">
	<cfif form.outputType eq "table">
	<cfoutput><span class="<cfif not val(getobject_indexes.numIndexes)>warning</cfif>"><span class="heavy label">#owner#.#name#</span> (#numberformat(val(getobject_indexes.record_count))# rows)</span></cfoutput>
	<cfif isdefined("getobject_indexes") and getobject_indexes.recordcount>	
	<div style="text-align: right;">
	<table border="0" cellpadding="4" cellspacing="1" class="bordered" width="98%">
	<tr>
		<td class="header c" width="1%">#</td>
		<td class="header" width="15%">INDEX NAME</td>
		<td class="header c" width="10%">TYPE</td>
		<td class="header" width="10%">EQUALITY COLUMNS</td>
		<td class="header" width="10%">INCLUDED COLUMNS</td>
		<td class="header c" width="4%">ENABLED</td>
		<td class="header c" width="4%">FILL</td>
		<td class="header c" width="4%">FRAG %</td>
		<td class="header c" width="8%">FRAGS/PAGES</td>
		<td class="header c" width="8%">ALLOC TYPE</td>
		<td class="header">NOTES</td> 
	</tr>
	<cfoutput query="getobject_indexes">
	<tr>
		<td class="r">#getobject_indexes.currentrow#</td>
		<td>#getobject_indexes.indexName#</td>
		<td>#getobject_indexes.type_desc#</td>
		<td>#replace(getobject_indexes.columns,",",", ","all")#</td>
		<td>#replace(getobject_indexes.includedColumns,",",", ","all")#</td>
		<td class="c"><cfif val(getobject_indexes.is_disabled)>NO<cfelse>YES</cfif></td>
		<td class="c">#getobject_indexes.fill_factor#</td>
		<td class="c">#decimalformat(getobject_indexes.avg_fragmentation_in_percent)#</td>
		<td class="c">#val(getobject_indexes.fragment_count)# / #val(getobject_indexes.page_count)#</td>
		<td class="c">#getobject_indexes.alloc_unit_type_desc#</td>
		<td></td>
	</tr>
	</cfoutput>
	</table>
	</div>
	<cfelse>
		<br>
	</cfif>
	<br><br>
	<cfelseif form.outputType eq "confluence">
<cfoutput><pre>h3. #owner#.#name# 
(#numberformat(val(getobject_indexes.record_count))# rows)</cfoutput>
<cfif isdefined("getobject_indexes") and getobject_indexes.recordcount>
||#||INDEX NAME||TYPE||EQUALITY COLUMNS||INCLUDED COLUMNS||ENABLED||FILL||FRAG %||FRAGMENTS/PAGES||ALLOC TYPE||NOTES||
<cfoutput query="getobject_indexes">|#getobject_indexes.currentrow#|#getobject_indexes.indexName#|#getobject_indexes.type_desc# |#replace(getobject_indexes.columns,",",", ","all")# |#replace(getobject_indexes.includedColumns,",",", ","all")# |<cfif val(getobject_indexes.is_disabled)>NO<cfelse>YES</cfif>|#getobject_indexes.fill_factor#|#decimalformat(getobject_indexes.avg_fragmentation_in_percent)#|#val(getobject_indexes.fragment_count)# / #val(getobject_indexes.page_count)#|#getobject_indexes.alloc_unit_type_desc# | |
</cfoutput>
<cfelse>
-none-</cfif></pre>
	</cfif>
	</cfif></cfif>
	</cfloop>