<cfsetting enablecfoutputonly = "yes">
	<cfinclude template="../udf/udf_secsToTime.cfm">	
	<cfparam name="activetab" type="string" default="overview">
	<cfset tablist = "overview,worstqueries,execobj,index,missing,unindexedfk,unused">
<cfsetting enablecfoutputonly = "no">

<cfif not dbx.guestmode>
<html>
<head>
	<title>DBX - Tuning Console</title><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
	<script type="text/javascript">
			APP = top; 
	</script><cfoutput>
	<script type="text/javascript" src="#dbxr.fullpathprefix#js/dbx_local.js"></script></cfoutput>
	<script type="text/javascript">
			// page tabs<cfoutput>
			var proftabs = new Array(#listqualify(tablist,"'")#);
			var activetab = '#activetab#'; </cfoutput>
			
			function switchTab(which) { 
				var which = (which != null) ? which : activetab; 
				
				for(var i=0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div') && document.getElementById(proftabs[i] + 'tab')) { 
						if(proftabs[i] == which) { 
							document.getElementById(proftabs[i] + 'div').className = 'pagedivon'; 
							document.getElementById(proftabs[i] + 'tab').className = 'pagetab on';
							activetab = which; 
						}
						else { 
							document.getElementById(proftabs[i] + 'div').className = 'pagediv'; 
							document.getElementById(proftabs[i] + 'tab').className = 'pagetab';		
						}
					}
				}
			}
	
			function setDivScrollers() { 
				var thirdheight = document.getElementById('third').offsetHeight; 
				for(var i = 0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div')) { 
							document.getElementById(proftabs[i] + 'div').style.height = thirdheight; 
					}
				}
			}
	
			function doresize() { 
				for(var i = 0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div')) { 
						document.getElementById(proftabs[i] + 'div').style.height = '1px'; 
					}
				}
				setDivScrollers(); 
				switchTab(activetab); 
			}
			
			function perfCodeView(itemname,which) { 
				var itemname = (itemname != null) ? itemname : ''; 
				var which = (which != null) ? which : ''; 
				
				if(itemname.length && document.getElementById(which).innerHTML.length) { 
					document.getElementById('itemname').value = itemname; 
					document.getElementById('code').value = document.getElementById(which).innerHTML; 
					 openWindow('about:blank','codeView');
					document.getElementById('codeform').target = 'codeView';
					document.getElementById('codeform').submit();
				} 
				else { 
					alert('There is no code to view.'); 
					return false; 
				}
			}
			
			onresize = doresize;
	</script>
</head>

	<body onload="setDivScrollers(); switchTab(activetab);">

	<table id="sourcelayout" border="0" cellpadding="0" cellspacing="0">
	<tr><td class="first">
		<table border="0" cellspacing="0" class="navbar"><cfoutput>
		<tr><td><div class="tab">Tuning Console [#defaultdb.name#]</div></td><td class="r nowrap"><a href="##" onclick="location.href='#dbxr.fullfilepathprefix#?tuning=1&activetab=' + activetab; return false;">REFRESH</a>&nbsp;</td></tr></cfoutput>
		</table>
	</td>
	</tr><cfif not isdefined("permissionErrors")>
	<tr><td class="second">
	<div id="pagetabs">
		<a id="overviewtab" href="#" class="pagetab on" onclick="switchTab('overview'); return false;">Overview</a>
		<a id="worstqueriestab" href="#" class="pagetab" onclick="switchTab('worstqueries'); return false;">Worst Performing Queries</a>
		<a id="execobjtab" href="#" class="pagetab" onclick="switchTab('execobj'); return false;">Highest Executions</a>
		<a id="indextab" href="#" class="pagetab" onclick="switchTab('index'); return false;">Index Usage</a>
		<a id="missingtab" href="#" class="pagetab" onclick="switchTab('missing'); return false;">Missing Indexes</a>
		<a id="unindexedfktab" href="#" class="pagetab" onclick="switchTab('unindexedfk'); return false;">Unindexed Foreign Keys</a>
		<a id="unusedtab" href="#" class="pagetab" onclick="switchTab('unused'); return false;">Unused Objects</a>
	</div>
	</td></tr>
<cfoutput><form name="codeform" id="codeform" action="#dbxr.fullfilepathprefix#?cv=1" target="_blank" method="post"><input type="hidden" name="itemname" id="itemname" value=""></cfoutput><input type="hidden" name="code" id="code" value=""></form>
	<tr><td class="third" id="third">
		
	<div id="overviewdiv" class="pagediv">
		<div class="pad">
<span class="heavy">Introduction</span>
<p>
Dynamic Management Views (DMV) and Dynamic Management Functions (DMF) return server state information that can be used to monitor the health of a server instance, diagnose problems, and tune performance. 
</p>
<p>
Note that SQL Server tracks the various usage and statistics data which underlie DMV's only from the last start of the server; that is, usage data and stats are reset each time the SQL Server service is cycled.  Keep this in mind when evaluating the results displayed by the Tuning Console.
</p>
<p>
You may set the number of objects returned in some of the tuning panes by setting the dbx.tuningTopX variable in config.cfm.  Default is 25.
</p>
<p>
Author's Note: DBX was created as a developer's tool, and was never intended to be used to administer SQL Server; as such, I've tried to include only the most relevant DMV data from a development standpoint, and have knowingly omitted DMV's that don't have a direct bearing on developing for SQL Server.  I plan to continue adding DMV's to DBX, and it's likely that I'll create a separate tool entirely which deals solely with SQL Server tuning and performance diagnosis.
</p>
		</div>
	<br><br>
	</div>
	
	<cftry>

		<div id="worstqueriesdiv" class="pagediv">
		<cf_tuning_worstqueries dbdsn="#dbdsn#" dbuser="#dbuser#" dbpass="#dbpass#" topx="#dbx.tuningTopX#">
		<br><br>
		</div>	
		
		<div id="execobjdiv" class="pagediv">
		<cf_tuning_highexec dbdsn="#dbdsn#" dbuser="#dbuser#" dbpass="#dbpass#" topx="#dbx.tuningTopX#">
		<br><br>
		<cf_tuning_highexecobj dbdsn="#dbdsn#" dbuser="#dbuser#" dbpass="#dbpass#" topx="#dbx.tuningTopX#">
		<br><br>
		</div>	
			
		<div id="indexdiv" class="pagediv">
		<cf_tuning_indexusagestats dbdsn="#dbdsn#" dbuser="#dbuser#" dbpass="#dbpass#">
		<br><br>
		</div>	
			
		<div id="missingdiv" class="pagediv">
		<cf_tuning_missingindexes dbdsn="#dbdsn#" dbuser="#dbuser#" dbpass="#dbpass#">
		<br><br>
		</div>	
			
		<div id="unindexedfkdiv" class="pagediv">
		<cf_tuning_unindexedforeignkeys dbdsn="#dbdsn#" dbuser="#dbuser#" dbpass="#dbpass#">
		<br><br>
		</div>	
			
		<div id="unuseddiv" class="pagediv">
		<cf_tuning_unusedobjects dbdsn="#dbdsn#" dbuser="#dbuser#" dbpass="#dbpass#">
		<br><br>
		</div>	

		<cfcatch>
			<cfdump var="#cfcatch#">
		</cfcatch>

	</cftry>
	
	</td></tr>
	<cfelse>
	<tr><td class="third" id="third">
	<div class="error">
	<cfoutput>#permissionErrors#</cfoutput>
	<cfif not isdefined("compatError")>
	<div class="c" style="margin-top: 20px;">
	<table border="0" cellpadding="3" cellspacing="0" style="border: none !important; width: 300px; margin: 0 auto;">
	<tr><td colspan="2"><span class="heavy">Override Login Values:</span></td></tr>
	<cfoutput><form action="#dbxr.fullfilepathprefix#?tuning=1" method="post"></cfoutput>
	<tr><td>Username:</td><td><cfoutput><input type="text" name="perfusername" value="#dbuser#"></td></tr><tr><td>Password:</td><td><input type="password" name="perfpassword" value="#dbpass#"></cfoutput></td></tr><tr><td colspan="2" class="c"><input type="submit" value="Submit" class="button"><input type="hidden" name="override" value="true"></td></tr></form>
	</table>
	</div>
	</cfif>
	</div>	
	</td></tr>
	</cfif>
	</table>
	</body>
	</html>

</cfif>