<cfif not dbx.guestmode>

<cfsetting enablecfoutputonly = "yes">

<cfparam name="form.perfusername" type="string" default="">
<cfparam name="form.perfpassword" type="string" default="">

<!--- we need this to set the db back to the default dsn db after querying master objects --->
<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="defaultdb">
	SELECT DB_NAME() AS name;
</cfquery>
		
<!--- verify version --->
<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="ver">
	SELECT ServerProperty('ProductVersion') AS theVersion
</cfquery>

<!--- parse the version --->
<cfset sqlServerVersion = "">
<cfset tempVersion = listfirst(ver.theVersion,".")>
<cfif val(tempVersion) gte 11>
	<cfset sqlServerVersion = " [SQL2012]">
<cfelseif tempVersion eq "10">
	<cfset sqlServerVersion = " [SQL2008]">
<cfelseif tempVersion eq "9">
	<cfset sqlServerVersion = " [SQL2005]">
<cfelseif tempVersion eq "8">
	<cfset sqlServerVersion = " [SQL2000]">
<cfelse>
	<!--- UNSUPPORTED VERSION --->
	<cfinclude template="../sqlserver/i_unsupported.cfm">
</cfif>

<cftry>

	<!--- check compatibility level --->
	<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="compat">
		SELECT compatibility_level FROM sys.databases WHERE database_id = DB_ID() 
	</cfquery>
	
	<cfif val(compat.compatibility_level) lt 90>
		<cfthrow type="InvalidCompatLevel" message="#compat.compatibility_level#">
	</cfif>
			
	<cfif not isdefined("form.override")>
		<!--- see if we already have valid user/pass override values --->
		<cfif isdefined("cookie.dbxor_perfusername")>
			<cfset form.perfusername = getCookie("dbxor_perfusername",dbx.enckey)>
		</cfif>
		<cfif isdefined("cookie.dbxor_perfpassword")>
			<cfset form.perfpassword = getCookie("dbxor_perfpassword",dbx.enckey)>
		</cfif>
	</cfif>
	
	<cfif len(form.perfusername)>
		<cfset dbuser = form.perfusername>
	</cfif>
	<cfif len(form.perfpassword)>
		<cfset dbpass = form.perfpassword>
	</cfif>
	
	<cf_tuning_testlogin dbdsn="#dbdsn#" dbuser="#dbuser#" dbpass="#dbpass#">
	
	<!--- set the override login values to a session cookie --->
	<cfif len(form.perfusername)>
		<cfset setCookie("dbxor_perfusername",form.perfusername,dbx.enckey,"SESSION",true)>
	</cfif>
	<cfif len(form.perfpassword)>
		<cfset setCookie("dbxor_perfpassword",form.perfpassword,dbx.enckey,"SESSION",true)>
	</cfif>
	
	<cfcatch type="InvalidCompatLevel">
		<cfset permissionErrors = "Tuning Console requires a minimum database compatibility level of 90 (SQL2005) to function.  Current database compatibility level is: #cfcatch.message#.<br><br>In order to take advantage of Tuning Console (or DMV's and DMF's within SQL Management Studio) you must change the compatibility level to 90.  Consult Books Online for details on how to do this.">
		<cfset compatError = true>
	</cfcatch>
	
	<cfcatch type="Database">
		<cfset permissionErrors = "Tuning Console requires access by a user login which has permissions to run system queries and objects.  The login used by the currently active datasource does not possess the proper permissions for use of the Tuning Console.<br><br><span class=""heavy"">The simplest solution is to login temporarily with the 'sa' login (or another login with VIEW SERVER STATE and VIEW DATABASE STATE permissions) by entering in the login data below - this will allow use of these credentials for the current session - these values are not stored persistently (nor is the datasource updated).</span><br><br>Note that it is never recommended to create datasources under the sa user for any purpose, although doing so would have prevented this dialog from appearing :)."><!--- <br><br><div class=""error"">The specific error encountered was: <span class=""heavy"">#cfcatch.message# #iif(len(cfcatch.detail),de(" | #cfcatch.detail#"),de(""))#</div> --->
	</cfcatch>
		
</cftry>

<cfsetting enablecfoutputonly = "no">

<cfinclude template="i_tuning.cfm">

</cfif>
<cfif not dbx.debugging>
	<cfsetting showdebugoutput="no">
</cfif>
