<!--- this template should set caller.errors = cfcatch for error handling --->

<cfparam name="attributes.dbdsn" type="string" default="">
<cfparam name="attributes.dbuser" type="string" default="">
<cfparam name="attributes.dbpass" type="string" default="">
<cfparam name="attributes.topx" type="numeric" default="5">

<cftry>
	
	<cfquery datasource="#attributes.dbdsn#" username="#attributes.dbuser#" password="#attributes.dbpass#" name="highexec">
			-- list statements with the highest execution counts
			SELECT TOP #attributes.topx#  
				qs.execution_count,
				SUBSTRING(qt.text,qs.statement_start_offset/2, 
				(case when qs.statement_end_offset = -1 
				then len(convert(nvarchar(max), qt.text)) * 2 
				else qs.statement_end_offset end -qs.statement_start_offset)/2) 
				as query_text,
				dbname=db_name(qt.dbid),
				objname=OBJECT_NAME(qt.objectid), 
				last_execution_time 
			FROM sys.dm_exec_query_stats qs
				cross apply sys.dm_exec_sql_text(qs.sql_handle) as qt 
			WHERE qt.dbid = DB_ID() 
			ORDER BY qs.execution_count DESC
	</cfquery>
	
	<cfoutput><div class="stableh">TOP #attributes.topx# STATEMENTS WITH HIGHEST EXECUTION COUNT [#dateformat(now(),'mm/dd/yyyy')# #lcase(timeformat(now(),'hh:mm:ss tt'))#]</div></cfoutput>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
		<tr><td class="stableh nowrap" width="10%" align=center>Executions</td><td class="stableh" width="80%">Query Text</td><td class="stableh" width="10%">Object</td></tr>
		<cfif highexec.recordcount>
		<cfoutput query="highexec">
		<tr><td class="r">#execution_count#</td><td>#query_text#</td><td>#objname#</td></tr>
		</cfoutput>
		<cfelse>
		<tr><td colspan="3" class="c">No data to display</td></tr>
		</cfif>
	</table>
	
	<cfcatch>
		<cfset caller.errors = cfcatch>
		<cfexit method="exittag">
	</cfcatch>

</cftry>
	
