<!--- this template should set caller.errors = cfcatch for error handling --->

<cfparam name="attributes.dbdsn" type="string" default="">
<cfparam name="attributes.dbuser" type="string" default="">
<cfparam name="attributes.dbpass" type="string" default="">
<cfparam name="attributes.topx" type="numeric" default="5">

<cftry>
	
	<cfquery datasource="#attributes.dbdsn#" username="#attributes.dbuser#" password="#attributes.dbpass#" name="highexecobj">
			-- list statements with the highest execution counts
			SELECT TOP #attributes.topx#  
				SUM(qs.execution_count) AS execution_count, 
				dbname=db_name(qt.dbid),
				objname=OBJECT_NAME(qt.objectid),
				MAX(last_execution_time) AS last_execution_time 
			FROM sys.dm_exec_query_stats qs
				cross apply sys.dm_exec_sql_text(qs.sql_handle) as qt 
			WHERE qt.dbid = DB_ID()  
			GROUP BY OBJECT_NAME(qt.objectid), db_name(qt.dbid) 
			ORDER BY execution_count DESC
	</cfquery>
	
	<cfoutput><div class="stableh">TOP #attributes.topx# OBJECTS WITH HIGHEST EXECUTION COUNT [#dateformat(now(),'mm/dd/yyyy')# #lcase(timeformat(now(),'hh:mm:ss tt'))#]</div></cfoutput>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
		<tr><td class="stableh nowrap" width="10%" align=center>Executions</td><td class="stableh" width="20%">Last Execution Time</td><td class="stableh" width="70%">Object</td></tr>
		<cfif highexecobj.recordcount>
		<cfoutput query="highexecobj">
		<tr><td class="r">#execution_count#</td><td class="nowrap">#dateformat(last_execution_time,'dd-mm-yyyy')# #timeformat(last_execution_time,'HH:mm:ss')#</td><td>#objname#</td></tr>
		</cfoutput>
		<cfelse>
		<tr><td colspan="3" class="c">No data to display</td></tr>
		</cfif>
	</table>
	
	<cfcatch>
		<cfset caller.errors = cfcatch>
		<cfexit method="exittag">
	</cfcatch>

</cftry>
	
