<!--- this template should set caller.errors = cfcatch for error handling --->

<cfparam name="attributes.dbdsn" type="string" default="">
<cfparam name="attributes.dbuser" type="string" default="">
<cfparam name="attributes.dbpass" type="string" default="">
<cfinclude template="../../core/udf/udf_formatSize.cfm">

<cftry>
	
	<cfquery datasource="#attributes.dbdsn#" username="#attributes.dbuser#" password="#attributes.dbpass#" name="indexusage">
		-- get index usage data 		
		SELECT 
			colname = c.name, 
			ic.is_included_column, 
			objname = object_name(ius.object_id), ius.object_id, ius.index_id, indexname = i.name, 
			ps.avg_fragmentation_in_percent, ps.index_type_desc, d.rows, 
			ius.user_seeks, ius.user_scans, ius.user_lookups, ius.user_updates, 
			ius.last_user_seek, ius.last_user_scan, ius.last_user_lookup, ius.last_user_update, 
			ius.system_seeks, ius.system_scans, ius.system_lookups, ius.system_updates, 
			ius.last_system_seek, ius.last_system_scan, ius.last_system_lookup, ius.last_system_update, 
			ps2.IndexSizeKB  
		FROM sys.dm_db_index_usage_stats ius 
			INNER JOIN sys.indexes i ON ius.OBJECT_ID = i.OBJECT_ID AND ius.index_id = i.index_id 
			INNER JOIN sys.index_columns ic ON i.OBJECT_ID = ic.OBJECT_ID AND i.index_id = ic.index_id 
			INNER JOIN sys.columns c ON ic.OBJECT_ID = c.OBJECT_ID AND ic.column_id = c.column_id 
			INNER JOIN sys.dm_db_index_physical_stats(DB_ID(), NULL, NULL, NULL, NULL) AS ps ON ps.object_id = ius.object_id AND ps.index_id = ius.index_id AND ps.database_id = ius.database_id 
			JOIN (
				SELECT  
						i2.object_id, 
				        i2.index_id,
				        8 * SUM(a2.used_pages) AS IndexsizeKB
				FROM    sys.indexes AS i2
				        JOIN sys.partitions AS p2 ON p2.object_id = i2.object_id AND p2.index_id = i2.index_id
				        JOIN sys.allocation_units AS a2 ON a2.container_id = p2.partition_id
				GROUP BY i2.object_id, i2.index_id   
			) ps2 ON ps2.object_id = ps.object_id AND ps2.index_id = ps.index_id 
			JOIN (
				SELECT dps.object_id, SUM(dps.row_count) AS rows
				FROM sys.dm_db_partition_stats dps
				WHERE dps.object_id > 100 
					AND dps.index_id < 2
				GROUP BY dps.object_id
			) d ON d.object_id = ius.object_id 
 		WHERE ius.database_id = DB_ID() 
			AND ius.OBJECT_ID > 100 -- filter out system objects 
		ORDER BY objname, indexname, colname 
	</cfquery>
	<style type="text/css">
	.lite { color: #999; font-size: 9px; line-height: 13px;}
	.fr { float: right; }
	.normal { font-weight: normal; text-transform: none; }
	</style>
	<cfoutput><div class="stableh">INDEX USAGE STATISTICS [#dateformat(now(),'mm/dd/yyyy')# #lcase(timeformat(now(),'hh:mm:ss tt'))#]</div></cfoutput>
	<cfif indexusage.recordcount>
	<cfoutput query="indexusage" group="objname">
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
		<tr>
			<td class="stableh2" colspan="4"><span class="normal fr">#numberformat(rows)# rows</span>Table: #objname#</td>
			<td class="stableh3 c" colspan="4">User</td>
			<td class="stableh4 c" colspan="4">System</td>
		</tr>
		<tr>
			<td class="stableh">Indexes</td>
			<td class="stableh c" width="100">Type</td>
			<td class="stableh c" width="80">Size</td>
			<td class="stableh c" width="80">Frag %</td>
			<td class="stableh c" width="80">Seeks</td>
			<td class="stableh c" width="80">Lookups</td>
			<td class="stableh c" width="80">Scans</td>
			<td class="stableh c" width="80">Updates</td>
			<td class="stableh c" width="80">Seeks</td>
			<td class="stableh c" width="80">Lookups</td>
			<td class="stableh c" width="80">Scans</td>
			<td class="stableh c" width="80">Updates</td>		
		</tr>
		<cfoutput group="indexname">
		<cfset collist = ""><cfset kcollist = ""><cfset icollist = "">
		<cfoutput>
			<cfif not val(is_included_column)>
				<cfset kcollist = listappend(kcollist,colname)>
			<cfelse>
				<cfset icollist = listappend(icollist,colname)>
			</cfif>
		</cfoutput>
		<cfif len(kcollist)>
			<cfset collist &= kcollist>
		</cfif>
		<cfif len(icollist)>
			<cfset collist &= " INCLUDE (" & icollist & ")">
		</cfif>
		<cfset collist = replace(collist,",",", ","all")>
		<tr>
			<td title="Columns: #collist#"><span>#indexname#</span></td>
			<td class="c" title="Type of Index"><span class="lite">#replacenocase(index_type_desc," INDEX","")#</span></td>
			<td class="r" title="Index Size">#formatSize(indexsizekb,"kb")#</td>
			<td class="r" title="Average Index Fragmentation in Percent"><cfif val(avg_fragmentation_in_percent)>#decimalformat(val(avg_fragmentation_in_percent))# %<cfelse>0</cfif></td>
			<td class="r" title="Last User Seek: <cfif isdate(last_user_seek)>#last_user_seek#<cfelse>N/A</cfif>">#numberformat(user_seeks)#</td>
			<td class="r" title="Last User Lookup: <cfif isdate(last_user_lookup)>#last_user_lookup#<cfelse>N/A</cfif>">#numberformat(user_lookups)#</td>
			<td class="r" title="Last User Scan: <cfif isdate(last_user_scan)>#last_user_scan#<cfelse>N/A</cfif>">#numberformat(user_scans)#</td>
			<td class="r" title="Last User Update: <cfif isdate(last_user_update)>#last_user_update#<cfelse>N/A</cfif>">#numberformat(user_updates)#</td>
			<td class="r" title="Last System Seek: <cfif isdate(last_system_seek)>#last_system_seek#<cfelse>N/A</cfif>">#numberformat(system_seeks)#</td>
			<td class="r" title="Last System Lookup: <cfif isdate(last_system_lookup)>#last_system_lookup#<cfelse>N/A</cfif>">#numberformat(system_lookups)#</td>
			<td class="r" title="Last System Scan: <cfif isdate(last_system_scan)>#last_system_scan#<cfelse>N/A</cfif>">#numberformat(system_scans)#</td>
			<td class="r" title="Last System Update: <cfif isdate(last_system_update)>#last_system_update#<cfelse>N/A</cfif>">#numberformat(system_updates)#</td>
		</tr>
		</cfoutput>
		</table>
		</cfoutput>
		<cfelse>
		<table border="0" cellpadding="0" cellspacing="1" class="stable">
			<tr><td class="c">No data to display</td></tr>
		</table>
		</cfif>
	
	<cfcatch><cfdump var="#cfcatch#">
		<cfset caller.errors = cfcatch>
		<cfexit method="exittag">
	</cfcatch>

</cftry>
	
