<!--- this template should set caller.errors = cfcatch for error handling --->

<cfparam name="attributes.dbdsn" type="string" default="">
<cfparam name="attributes.dbuser" type="string" default="">
<cfparam name="attributes.dbpass" type="string" default="">

<cftry>
	
	<cfquery datasource="#attributes.dbdsn#" username="#attributes.dbuser#" password="#attributes.dbpass#" name="missing">
		-- get missing indexes 
		SELECT  
			mid.database_id, 
			mid.object_id, 
			mid.statement AS table_name, 
			mig.index_handle AS index_handle, 
			mid.equality_columns, 
			mid.inequality_columns, 
			mid.included_columns, 
			migs_adv.index_advantage
		FROM (
				SELECT (user_seeks+user_scans) * avg_total_user_cost * (avg_user_impact * 0.01) as index_advantage, migs.*
				FROM sys.dm_db_missing_index_group_stats migs
			) AS migs_adv,
			sys.dm_db_missing_index_groups mig,
			sys.dm_db_missing_index_details mid
		WHERE 
			mid.database_id = DB_ID() 
			AND migs_adv.group_handle = mig.index_group_handle 
			AND mig.index_handle = mid.index_handle 
		ORDER BY 
			mid.statement, migs_adv.index_advantage DESC
	</cfquery>
	
	<cfoutput><div class="stableh">MISSING INDEXES [#dateformat(now(),'mm/dd/yyyy')# #lcase(timeformat(now(),'hh:mm:ss tt'))#]</div></cfoutput>
	<cfif missing.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
		<tr>
			<td class="stableh">Table</td>
			<td class="stableh c" width="5%">Advantage</td>
			<td class="stableh c" width="20%">Equality Columns</td>
			<td class="stableh c" width="20%">Inequality Columns</td>
			<td class="stableh c" width="20%">Included Columns</td>
		</tr><cfset currtable = missing.table_name[1]>
		<cfoutput query="missing">
		<cfif missing.table_name neq currtable>
			<tr><td colspan="5">&nbsp;</td></tr>
			<cfset currtable = missing.table_name>
		</cfif>
		<tr>
			<td>#table_name#</td>
			<td class="r">#decimalformat(index_advantage)#</td>
			<td>#equality_columns#&nbsp;</td>
			<td>#inequality_columns#&nbsp;</td>
			<td>#included_columns#&nbsp;</td>
		</tr>
		</cfoutput>
		</table>
		<cfelse>
		<table border="0" cellpadding="0" cellspacing="1" class="stable">
			<tr><td class="c">No data to display</td></tr>
		</table>
		</cfif>
	
	<cfcatch>
		<cfset caller.errors = cfcatch>
		<cfexit method="exittag">
	</cfcatch>

</cftry>
	
