<!--- this template should set caller.errors = cfcatch for error handling --->

<cfparam name="attributes.dbdsn" type="string" default="">
<cfparam name="attributes.dbuser" type="string" default="">
<cfparam name="attributes.dbpass" type="string" default="">

<cftry>
	
	<cfquery datasource="#attributes.dbdsn#" username="#attributes.dbuser#" password="#attributes.dbpass#" name="unindexedfk">
		SELECT 
			table_name = object_name(t.object_id),
			column_name = c.name  
		FROM 
			sys.columns c 
			LEFT JOIN sys.tables t ON (c.object_id = t.object_id) 
			LEFT JOIN sys.foreign_key_columns fkc ON (fkc.parent_object_id = c.object_id AND c.column_id = fkc.parent_column_id)
			LEFT JOIN sys.foreign_keys fk ON (fkc.constraint_object_id = fk.object_id) 
			LEFT JOIN sys.index_columns ic ON (ic.object_id = c.object_id AND ic.column_id = c.column_id)	
			LEFT JOIN sys.indexes i ON (I.index_id = ic.index_id  AND i.object_id = c.object_id)
		WHERE 			
			t.object_id IS NOT NULL 
			AND fk.name IS NOT NULL
			AND i.name IS NULL
		ORDER BY  
			table_name, 
			column_name 
	</cfquery>
	
	<cfoutput><div class="stableh">UNINDEXED FOREIGN KEYS [#dateformat(now(),'mm/dd/yyyy')# #lcase(timeformat(now(),'hh:mm:ss tt'))#]</div></cfoutput>
	<cfif unindexedfk.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
		<tr>
			<td class="stableh" width="40%">Table</td>
			<td class="stableh">Columns</td>
		</tr>
		<cfoutput query="unindexedfk" group="table_name">
		<tr>
			<td>#table_name#</td>
			<td><cfoutput>#column_name#<br></cfoutput></td>
		</tr>
		</cfoutput>
		</table>
		<cfelse>
		<table border="0" cellpadding="0" cellspacing="1" class="stable">
			<tr><td class="c">No data to display</td></tr>
		</table>
		</cfif>
	
	<cfcatch>
		<cfset caller.errors = cfcatch>
		<cfexit method="exittag">
	</cfcatch>

</cftry>
	
