<!--- this template should set caller.errors = cfcatch for error handling --->

<cfparam name="attributes.dbdsn" type="string" default="">
<cfparam name="attributes.dbuser" type="string" default="">
<cfparam name="attributes.dbpass" type="string" default="">

<cftry>
	
	<cfquery datasource="#attributes.dbdsn#" username="#attributes.dbuser#" password="#attributes.dbpass#" name="unusedobj">
		-- get unused or rarely used tables and indexes
		SELECT  
			objectname = OBJECT_NAME(ind.object_id),
			indexname = ind.name
		FROM
			sys.indexes ind
			INNER JOIN sys.objects obj ON obj.object_id = ind.object_id
		WHERE
			OBJECTPROPERTY(obj.object_id,'IsUserTable') = 1  
			AND NOT EXISTS
				(
					SELECT 1
					FROM
						sys.dm_db_index_usage_stats usg
					WHERE 
						usg.database_id = DB_ID()  
						AND usg.object_id = ind.object_id 
						AND usg.index_id = ind.index_id
						AND ind.index_id = usg.index_id
				)
		ORDER BY 
			objectname, index_id, indexname 
	</cfquery>
	
	<cfoutput><div class="stableh">UNUSED TABLES AND INDEXES [#dateformat(now(),'mm/dd/yyyy')# #lcase(timeformat(now(),'hh:mm:ss tt'))#]</div></cfoutput>
	<cfif unusedobj.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
		<tr>
			<td class="stableh" width="40%">Table</td>
			<td class="stableh">Indexes</td>
		</tr>
		<cfoutput query="unusedobj" group="objectname">
		<tr>
			<td>#objectname#</td>
			<td><cfoutput>#indexname#<br></cfoutput></td>
		</tr>
		</cfoutput>
		</table>
		<cfelse>
		<table border="0" cellpadding="0" cellspacing="1" class="stable">
			<tr><td class="c">No data to display</td></tr>
		</table>
		</cfif>
	
	<cfcatch>
		<cfset caller.errors = cfcatch>
		<cfexit method="exittag">
	</cfcatch>

</cftry>
	
