<!--- this template should set caller.errors = cfcatch for error handling --->

<cfparam name="attributes.dbdsn" type="string" default="">
<cfparam name="attributes.dbuser" type="string" default="">
<cfparam name="attributes.dbpass" type="string" default="">
<cfparam name="attributes.topx" type="numeric" default="5">

<cftry>
	
	<cfquery datasource="#attributes.dbdsn#" username="#attributes.dbuser#" password="#attributes.dbpass#" name="highcpu">
		-- list statements with highest average cpu time			
		SELECT TOP #attributes.topx#  
			qs.total_worker_time/qs.execution_count as avgCPUTime,
			SUBSTRING(qt.text,qs.statement_start_offset/2, 
			(case when qs.statement_end_offset = -1 
			then len(convert(nvarchar(max), qt.text)) * 2 
			else qs.statement_end_offset end -qs.statement_start_offset)/2) 
			as query_text,
			qt.dbid, dbname=db_name(qt.dbid),
			objname=OBJECT_NAME(qt.objectid), 
			objOwner = schema_name(so.[schema_id]), 
			objType = so.type, 
			last_execution_time, 
			execution_count, 
			qs.total_worker_time AS totalCPUTime 
		FROM sys.dm_exec_query_stats qs
			cross apply sys.dm_exec_sql_text(qs.sql_handle) as qt 
			inner join sys.objects so on qt.objectid = so.[object_id]  
		WHERE qt.dbid = DB_ID()  
		ORDER BY avgCPUTime DESC
	</cfquery>
	
	<cfoutput><div class="stableh">TOP #attributes.topx# WORST PERFORMING QUERIES [#dateformat(now(),'mm/dd/yyyy')# #lcase(timeformat(now(),'hh:mm:ss tt'))#]</div></cfoutput>
	<cfif highcpu.recordcount>
	<cfoutput query="highcpu">
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
		<tr><td class="stableh nowrap" width="10%">Avg CPU Time</td><td>#avgCPUTime#</td></tr>
		<tr><td class="stableh nowrap" width="10%">Object</td><td>#objname# [#objOwner#] #objType#</td></tr>
		<tr><td class="stableh nowrap" width="10%">Num Executions</td><td>#execution_count#</td></tr>
		<tr><td class="stableh nowrap" width="10%">Last Executed</td><td>#dateformat(last_execution_time,'dd-mm-yyyy')# #timeformat(last_execution_time,'HH:mm:ss')#</td></tr>
		<tr><td class="stableh nowrap" width="10%">Total CPU Time</td><td>#totalCPUTime#</td></tr>
		<tr><td class="stableh nowrap" width="10%">Query Text <a href="##" onclick="perfCodeView('#objname#','qt_1_#currentrow#'); return false;" title="View in Code Viewer" class="cvb">[&curren;]</a></td><td id="qt_1_#currentrow#">#query_text#</td></tr>
	</table>
	</cfoutput>
	<cfelse>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
		<tr><td class="c">No data to display</td></tr>
	</table>
	</cfif>
	
	<cfcatch>
		<cfset caller.errors = cfcatch>
		<cfexit method="exittag">
	</cfcatch>

</cftry>
	
