<cfsetting enablecfoutputonly="yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	1.0
	
	@description: 	
   		converts sqlserver's TYPE_NAME value to equivalent 
		CF_SQL_TYPE 
		returns a string
		
	@changelog: 
		[version - date - author - comment]
		1.0.0 - 5/9/2005 - Kevin Miller - creation 
------------------------------------------------------------------ --->

<cfscript>
	function getCFSQLType(type) { 
		var returnVal = ""; 
		switch(type)
		{
		  case "bigint": 
		  returnVal = "CF_SQL_BIGINT"; 
		 	break;
		  case "bit": 
		  returnVal = "CF_SQL_BIT"; 
		    break;
		  case "char": case "nchar":  
		  returnVal = "CF_SQL_CHAR"; 
		    break;
		  case "datetime": case "smalldatetime":  
		  returnVal = "CF_SQL_TIMESTAMP"; 
		    break;
		  case "decimal": case "money": case "smallmoney": 
		  returnVal = "CF_SQL_DECIMAL"; 
		    break;
		  case "double": 
		  returnVal = "CF_SQL_DOUBLE"; 
		    break;
		  case "image": 
		  returnVal = "CF_SQL_LONGVARBINARY"; 
		    break;
		  case "float": 
		  returnVal = "CF_SQL_FLOAT"; 
		    break;
		  case "uniqueidentifier": 
		  returnVal = "CF_SQL_IDSTAMP"; 
		    break;
		  case "int": case "int identity":  
		  returnVal = "CF_SQL_INTEGER"; 
		    break;
		  case "text": case "ntext":  
		  returnVal = "CF_SQL_LONGVARCHAR"; 
		    break;
		  case "numeric": 
		  returnVal = "CF_SQL_NUMERIC"; 
		    break;
		  case "real": 
		  returnVal = "CF_SQL_REAL"; 
		    break;
		  case "cursor": 
		  returnVal = "CF_SQL_REFCURSOR"; 
		    break;
		  case "smallint": 
		  returnVal = "CF_SQL_SMALLINT"; 
		    break;
		  case "time": 
		  returnVal = "CF_SQL_TIME"; 
		    break;
		  case "timestamp": 
		  returnVal = "CF_SQL_BINARY"; // this is a binary read only field in sqlserver 
		    break;
		  case "tinyint": 
		  returnVal = "CF_SQL_TINYINT"; 
		    break;
		  case "varbinary": 
		  returnVal = "CF_SQL_VARBINARY"; 
		    break;
		  case "varchar": case "nvarchar": case "sysname":  
		  returnVal = "CF_SQL_VARCHAR"; 
		    break;
			
		  default:
		    returnVal = "UNKNOWN";; 
		} 
		return returnVal; 
		}
</cfscript>
<cfsetting enablecfoutputonly="no">