<cfsetting enablecfoutputonly="yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		8/29/2007
	@version:	1.0
	
	@description: 	
   		returns cfqueryparam/cfprocparam NULL handling based upon TYPE_NAME value 
		returns a string 
------------------------------------------------------------------ --->

<cfscript>
	function getNULLHandler(type) { 
		var returnVal = ""; 
		switch(type)
		{
		  case "bigint": 
		  returnVal = "##!isNumeric(```REPLACEME```)##"; 
		 	break;
		  case "bit": 
		  returnVal = "##!isBoolean(```REPLACEME```)##"; 
		    break;
		  case "char": case "nchar":  
		  returnVal = "##!len(```REPLACEME```)##"; 
		    break;
		  case "datetime": case "smalldatetime":  
		  returnVal = "##!isDate(```REPLACEME```)##"; 
		    break;
		  case "decimal": case "money": case "smallmoney": 
		  returnVal = "##!isNumeric(```REPLACEME```)##"; 
		    break;
		  case "double": 
		  returnVal = "##!isNumeric(```REPLACEME```)##"; 
		    break;
		  case "image": 
		  returnVal = "##!isBinary(```REPLACEME```)##"; 
		    break;
		  case "float": 
		  returnVal = "##!isNumeric(```REPLACEME```)##"; 
		    break;
		  case "uniqueidentifier": 
		  returnVal = "##!isValid(""guid"",```REPLACEME```)##"; 
		    break;
		  case "int": case "int identity":  
		  returnVal = "##!isNumeric(```REPLACEME```)##"; 
		    break;
		  case "text": case "ntext":  
		  returnVal = "##!len(```REPLACEME```)##"; 
		    break;
		  case "numeric": 
		  returnVal = "##!isNumeric(```REPLACEME```)##"; 
		    break;
		  case "real": 
		  returnVal = "##!isNumeric(```REPLACEME```)##"; 
		    break;
		  case "cursor": 
		  returnVal = "false"; 
		    break;
		  case "smallint": 
		  returnVal = "##!isNumeric(```REPLACEME```)##"; 
		    break;
		  case "time": 
		  returnVal = "##!isDate(```REPLACEME```)##"; 
		    break;
		  case "timestamp": 
		  returnVal = "##!isBinary(```REPLACEME```)##"; // this is a binary read only field in sqlserver 
		    break;
		  case "tinyint": 
		  returnVal = "##!isNumeric(```REPLACEME```)##"; 
		    break;
		  case "varbinary": 
		  returnVal = "##!isBinary(```REPLACEME```)##"; 
		    break;
		  case "varchar": case "nvarchar": case "sysname":  
		  returnVal = "##!len(```REPLACEME```)##"; 
		    break;
			
		  default:
		    returnVal = "false"; 
		} 
		return returnVal; 
		}
</cfscript>
<cfsetting enablecfoutputonly="no">