// dbx.js 6-1-2004

// browser detection
DOM = (document.getElementById) ? true : false;
NS4 = (document.layers) ? true : false;
IE4 = (document.all) ? true : false;
NS6 = DOM && !IE4;
IsOK = (NS6 || IE4);

// mouse position
document.onmousemove = getPos;

function getPos(loc) {
		if (NS6) { px = loc.pageX; py = loc.pageY; }
		if (IE4) { px = (event.clientX + document.body.scrollLeft); py = (event.clientY + document.body.scrollTop); }
	}
var px,py;

// writes status display to bottom status frame's div 
function writeStatus( number ) {
	var text = '';
	switch(number) {
		case 0: 
			text = 'Idle';
			break;
		case 1: 
			text = 'Retrieving Database Metadata...';
			break;
		case 2: 
			text = 'Loading Database Object Tree...';
			break;
		case 3: 
			text = 'Loading Master Database Object Tree...';
			break;
	}
	if(frames.statusframe) {
		if(statusframe.document.getElementById('statusdisplay')) {
			statusframe.document.getElementById('statusdisplay').innerHTML = text;
		}
	}
}

function clearErrors() {
	if(frames.statusframe) {
		statusframe.errors = '';
		handleErrorBTN();
	}
}

function writeErrors( text ) {
	if(frames.statusframe) {
		statusframe.errors += text + '\n\n';
		handleErrorBTN();
	}
}
		
function handleErrorBTN() {
	if(frames.statusframe) {
		if(!statusframe.errors.length) {
			statusframe.document.getElementById('errorBTN').style.visibility = 'hidden';
		}
		else {
			statusframe.document.getElementById('errorBTN').style.visibility = 'visible';
		}
	} 
}

function displayErrors() {
	alert(statusframe.errors);
}
		
function wS( text ) {
	text = (text == null) ? '' : text;
	top.window.status = text; 
	return true;
}

function getElement(id){
	if (document.getElementById)
		return document.getElementById(id);
	if (document.all)
		return document.all[id];
	
	return null;
}

function subColorizeCFML( text ) {

	text = text.replace(/(\x13\/?cf[^\x14]*\x14)/gi, '<span class=\"cfml1\">$1</span>'); // cf tags		

	// multiline comment
	text = text.replace(/(\x11[^\x12]*\x12)/gim, '<span class=\"cfmlcomment\">$1</span>'); 

	return text;
}

function subColorizeHTML( text ) {

		// highlight quoted strings
		// text = text.replace(/("[^"]*")/gim, '<span class=\"htmlquoted\">$1</span>'); // double
		// text = text.replace(/('[^']*')/gim, '<span class=\"htmlquoted\">$1</span>'); // single
		text = text.replace(/("[^"]*")/gi, '<span class=\"htmlquoted\">$1</span>'); // double
		text = text.replace(/('[^']*')/gi, '<span class=\"htmlquoted\">$1</span>'); // single
		
		// Block Elements
		text = text.replace(/(\x13\/?(address|blockquote|center|div|h1|h2|h3|h4|h5|h6|p|pre)[^\x14]*\x14)/gi, '<span class=\"htmlblock\">$1</span>');
		
		// HTML Form
		text = text.replace(/(\x13\/?(button|fieldset|form|input|isindex|label|legend|optgroup|option|select|textarea)[^\x14]*\x14)/gi, '<span class=\"htmlform\">$1</span>');
		
		// HTML Format
		text = text.replace(/(\x13\/?(abbr|acronym|bdo|big|cite|code|del|dfn|em|font|ins|kbd|samp|small|span|strike|strong|sub|sup|tt|u|var)[^\x14]*\x14)/gi, '<span class=\"htmlformat\">$1</span>');
		
		// HTML deprecated Format crap, screws up other regex statements
		text = text.replace(/(\x13\/?(b|i|q)\x14)/gi, '<span class=\"htmlformat\">$1</span>');
		
		// HTML Frame
		text = text.replace(/(\x13\/?(frame|frameset|iframe|noframes)[^\x14]*\x14)/gi, '<span class=\"htmlframe\">$1</span>');
		
		// HTML Image
		text = text.replace(/(\x13\/?(img)[^\x14]*\x14)/gi, '<span class=\"htmlimage\">$1</span>');
		
		// HTML Image Map
		text = text.replace(/(\x13\/?(area|map)[^\x14]*\x14)/gi, '<span class=\"htmlmap\">$1</span>');
		
		// HTML Link
		text = text.replace(/(\x13\/?(a)[^\x14]*\x14)/gi, '<span class=\"htmllink\">$1</span>');
		
		// HTML List
		text = text.replace(/(\x13\/?(dd|dir|dl|dt|menu|ol|ul|li)[^\x14]*\x14)/gi, '<span class=\"htmllist\">$1</span>');
		
		// HTML Media
		text = text.replace(/(\x13\/?(applet|object|param)[^\x14]*\x14)/gi, '<span class=\"htmlmedia">$1</span>');
		
		// HTML Structure
		text = text.replace(/(\x13\/?(!doctype|base|basefont|body|head|html|link|meta|title)[^\x14]*\x14)/gi, '<span class=\"htmlstructure\">$1</span>');
		
		// HTML Table
		text = text.replace(/(\x13\/?(caption|col|colgroup|table|td|tbody|tfoot|th|thead|tr)[^\x14]*\x14)/gi, '<span class=\"htmltable\">$1</span>');
		
		// HTML Whitespace
		text = text.replace(/(\x13\/?(br|hr|nobr|spacer|wbr)[^\x14]*\x14)/gi, '<span class=\"htmlwhitespace\">$1</span>');

		// HTML Comment
		text = text.replace(/(\x18[^\x19]*\x19)/gim, '<span class=\"htmlcomment\">$1</span>'); 
		
		// style block handling
			// pseudo escape </style> tag
			/* text = text.replace(/(\x13\/[style]\x14)/gi, unescape('%1C'));
			
			alert(text);
			
			styleArray = text.match(/(\x13[style]\x14[^\x1C]*\x1C)/gi);
			alert(styleArray); */
		
		
		// HTML Style
		text = text.replace(/(\x13\/?(style)[^\x14]*\x14)/gi, '<span class=\"htmlstyle\">$1</span>');
		
		return text; 
}	

function subColorizeJS( text ) {

		// highlight quoted strings
		text = text.replace(/("[\w]+")/gim, '<span class=\"jsquoted\">$1</span>'); // double
		text = text.replace(/('[\w]+')/gim, '<span class=\"jsquoted\">$1</span>'); // single
		
		// reserved words
		text = text.replace(/\b(abstract|boolean|break|byte|case|catch|char|const|continue|default|do|double|else|extends|false|final|finally|float|for|function|goto|if|implements|import|in|instanceof|int|interface|long|native|new|null|package|private|protected|public|return|short|static|super|switch|synchroniz|this|throw|throws|transient|true|try|var|void|while|with)\b/gi, '<span class=\"jsreserved\">$1</span>');
		
		// built in methods
		text = text.replace(/\b(abs|acos|alert|anchor|asin|atan|back|big|blink|blur|bold|ceil|charAt|clear|clearTimeout|click|close|confirm|cos|escape|eval|exp|fixed|floor|focus|fontcolor|fontsize|forward|getDate|getDay|getHours|getMinutes|getMonth|getSeconds|getTime|getTimezoneOffset|getYear|go|indexOf|isNaN|italics|lastIndexOf|link|log|max|min|open|parse|parseFloat|parseInt|pow|prompt|random|round|select|setDate|setHours|setMinutes|setMonth|setSeconds|setTimeout|setTime|setYear|sin|small|sqrt|strike|sub|submit|substring|sup|tan|toGMTString|toLocaleString|toLowerCase|toUpperCase|unescape|UTC|write|writeln)\b/gi, '<span class=\"jsbuiltin\">$1</span>');

		// single comment
		text = text.replace(/(\/\/[^\n]*\s+)/gi, '<span class=\"jscomment\">$1</span>');
		
		// multiline comment
		text = text.replace(/(\/[\*]+([^\*]*?)[\*]+\/)/gim, '<span class=\"jscomment\">$1</span>');
		
		// do something with numbers
		text = text.replace(/\b(\d+)\b/gi, '<span class=\"numbers\">$1</span>');
		
		return text; 
}

function subColorizeSQL( text ) {

		// highlight quoted strings
		text = text.replace(/("[\w]+")/gim, '<span class=\"sqlquoted\">$1</span>'); // double
		text = text.replace(/('[\w]+')/gim, '<span class=\"sqlquoted\">$1</span>'); // single
		
		// blue
		text = text.replace(/\b(ADD|EXCEPT|PERCENT|EXEC|PLAN|ALTER|EXECUTE|PRECISION|PRIMARY|EXIT|PRINT|AS|FETCH|PROC|ASC|FILE|PROCEDURE|AUTHORIZATION|FILLFACTOR|PUBLIC|BACKUP|FOR|RAISERROR|BEGIN|FOREIGN|READ|FREETEXT|READTEXT|BREAK|FREETEXTTABLE|RECONFIGURE|BROWSE|FROM|REFERENCES|BULK|FULL|REPLICATION|BY|FUNCTION|RESTORE|CASCADE|GOTO|RESTRICT|GRANT|RETURN|CHECK|GROUP|REVOKE|CHECKPOINT|HAVING|CLOSE|HOLDLOCK|ROLLBACK|CLUSTERED|IDENTITY_INSERT|ROWGUIDCOL|COLLATE|IDENTITYCOL|RULE|COLUMN|IF|SAVE|COMMIT|SCHEMA|COMPUTE|INDEX|SELECT|CONSTRAINT|INNER|CONTAINS|INSERT|SET|CONTAINSTABLE|INTERSECT|SETUSER|CONTINUE|INTO|SHUTDOWN|IS|CREATE|STATISTICS|KEY|CURRENT|KILL|TABLE|CURRENT_DATE|CURRENT_TIME|LINENO|TO|LOAD|TOP|CURSOR|NATIONAL|TRAN|DATABASE|NOCHECK|TRANSACTION|DBCC|NONCLUSTERED|TRIGGER|DEALLOCATE|TRUNCATE|DECLARE|TSEQUAL|DEFAULT|UNION|DELETE|OF|UNIQUE|DENY|OFF|UPDATE|DESC|OFFSETS|UPDATETEXT|DISK|ON|USE|DISTINCT|OPEN|THEN|DISTRIBUTED|OPENDATASOURCE|VALUES|DOUBLE|OPENQUERY|VARYING|DROP|OPENROWSET|VIEW|DUMMY|OPENXML|WAITFOR|DUMP|OPTION|WHEN|ELSE|WHERE|END|ORDER|WHILE|ERRLVL|WITH|ESCAPE|OVER|WRITETEXT)\b/gi, '<span class=\"sqlblue\">$1</span>');
		
		// gray
		text = text.replace(/\b(ALL|AND|EXISTS|ANY|BETWEEN|IN|SOME|JOIN|OR|OUTER|CROSS|LIKE|NOT|NULL)\b/gi, '<span class=\"sqlgray\">$1</span>');
		
		// pink
		text = text.replace(/\b(CASE|RIGHT|COALESCE|SESSION_USER|CONVERT|SYSTEM_USER|LEFT|CURRENT_TIMESTAMP|CURRENT_USER|NULLIF|USER)\b/gi, '<span class=\"sqlpink\">$1</span>');
	
		// single comment
		text = text.replace(/(--[^\n]*\s+)/gi, '<span class=\"sqlcomment\">$1</span>');
		
		// multiline comment
		text = text.replace(/(\/[\*]+([^\*]*?)[\*]+\/)/gim, '<span class=\"sqlcomment\">$1</span>');
		
		// unaccounted for in QA color scheme
		// IDENTITY ROWCOUNT TEXTSIZE 
		
		// do something with numbers
		text = text.replace(/\b(\d+)\b/gi, '<span class=\"numbers\">$1</span>');
		
		return text; 
}

function subColorizeCSS( text ) {

		// highlight quoted strings
		// text = text.replace(/("[\w]+")/gim, '<span class=\"jsquoted\">$1</span>'); // double
		// text = text.replace(/('[\w]+')/gim, '<span class=\"jsquoted\">$1</span>'); // single
		
		// words
		// text = text.replace(/({[^{]*})/gim, '<span class=\"cssword\">$1</span>');		
		
		// declarations
		text = text.replace(/({|})/gi, '<span class=\"cssdeclaration\">$1</span>');
		
		// values
		text = text.replace(/(:)([^;}]*)([;|}])/gi, '$1<span class=\"cssvalue\">$2</span>$3');

		
		// built in methods
		text = text.replace(/\b(background|background-attachment|background-color|background-image|background-position|background-repeat|border|border-collapse|border-color|border-spacing|border-style|border-top|border-right|border-bottom|border-left|border-top-color|border-right-color|border-bottom-color|border-left-color|border-top-style|border-right-style|border-bottom-style|border-left-style|border-top-width|border-right-width|border-bottom-width|border-left-width|border-width|bottom|caption-side|clear|clip|color|content|counter-increment|counter-reset|cursor|direction|display|empty-cells|float|font|font-family|font-size|font-size-adjust|font-stretch|font-style|font-variant|font-weight|height|left|letter-spacing|line-height|list-style|list-style-image|list-style-position|list-style-type|margin|margin-top|margin-right|margin-bottom|margin-left|marker-offset|marks|max-height|max-width|min-height|min-width|orphans|outline|outline-color|outline-style|outline-width|overflow|padding|padding-top|padding-right|padding-bottom|padding-left|page|page-break-after|page-break-before|page-break-inside|position|quotes|right|size|table-layout|text-align|text-decoration|text-indent|text-shadow|text-transform|top|unicode-bidi|vertical-align|visibility|white-space|widows|width|word-spacing|z-index)\b/gi, '<span class=\"cssproperty\">$1</span>');

		// escape html escape codes - we need this for when the css colorizer is applied to html type content
		// and is necessary so as not to whack the punctuation coloring below
		text = text.replace(/(&lt;)/gi, '```KLEFTANGLE```' ); // < pre-escaping
		text = text.replace(/(&gt;)/gi, '```KRIGHTANGLE```' ); // > pre-escaping
		
			// css punctuation
			text = text.replace(/([.|,|:|;|!])/g, '<span class=\"csspunct\">$1</span>');
					
			text = text.replace(/```KLEFTANGLE```/gi, '&lt;' ); // < unescaping
			text = text.replace(/```KRIGHTANGLE```/gi, '&gt;' ); // > unescaping
				
		// multiline comment
		text = text.replace(/(\/[\*]+([^\*]*?)[\*]+\/)/gim, '<span class=\"csscomment\">$1</span>');
		
		// for words, arbitrarily wrap the whole thing, failed on inverting the cssword match above
		if(text.substr(0,5).toLowerCase == '<pre>') { // this is a css only content colorization
			text = text.replace(/^(<pre>)/im,'$1<span class=\"cssword\">');
			text = text.replace(/(<\/pre>)$/im,'</span>$1');
		}
		else { // this is a call from another routine for inside style blocks
			text = '<span class=\"cssword\">' + text + '</span>';
		}
		return text; 
}

function colorize(element, type){
	type = (type == null) ? 'sql' : type;
	theElement = getElement(element);
	output = getElement(element).innerHTML;
	
	if (!output.length)
		return;

	switch ( type ) {  
	
		case 'html' : 
		/* HTML SPECIFIC COLORIZING */
		// escape all occurrences of escaped <!--- and ---> with a single char counterpart for our regexes
		output = output.replace(/(&lt;!--)/gi, unescape('%18') ); // < pre-escaping
		output = output.replace(/(--&gt;)/gi, unescape('%19') ); // > pre-escaping
		
		// start by escaping all occurrences of escaped < and > with a single char counterpart for our regexes
		output = output.replace(/(&lt;)/gi, unescape('%13') ); // < pre-escaping
		output = output.replace(/(&gt;)/gi, unescape('%14') ); // > pre-escaping
		
		output = subColorizeHTML( output );	
		
		// unescape our pseudo prep routine
		output = output.replace(/(\x13)/gi, '&lt;' ); // < unescaping
		output = output.replace(/(\x14)/gi, '&gt;' ); // > unescaping
		output = output.replace(/(\x18)/gi, '&lt;!--' ); // <!--- unescaping
		output = output.replace(/(\x19)/gi, '--&gt;' ); // ---> unescaping
		
		break; 

		case 'cfml' : 		
		/* CFML SPECIFIC COLORIZING */

		// escape all occurrences of escaped <!--- and ---> with a single char counterpart for our regexes
		output = output.replace(/(&lt;!---)/gi, unescape('%11') ); // < pre-escaping
		output = output.replace(/(---&gt;)/gi, unescape('%12') ); // > pre-escaping
		
		// escape all occurrences of escaped < and > with a single char counterpart for our regexes
		output = output.replace(/(&lt;)/gi, unescape('%13') ); // < pre-escaping
		output = output.replace(/(&gt;)/gi, unescape('%14') ); // > pre-escaping
		
		output = subColorizeHTML(output); 
		output = subColorizeCFML( output ); 
		
		// unescape our pseudo prep routine
		output = output.replace(/(\x13)/gi, '&lt;' ); // < unescaping
		output = output.replace(/(\x14)/gi, '&gt;' ); // > unescaping
		output = output.replace(/(\x11)/gi, '&lt;!---' ); // <!--- unescaping
		output = output.replace(/(\x12)/gi, '---&gt;' ); // ---> unescaping
		
		break; 
		
		case 'sql' : 
		/* SQL SPECIFIC COLORIZING 
		   this color scheme is identical to that used in Query Analyzer
		*/
	
		output = subColorizeSQL( output ); 
		
		break;

		case 'js' : 
		/* JAVASCRIPT SPECIFIC COLORIZING */

		output = subColorizeJS( output ); 
		
		break;

		case 'css' : 
		/* CSS SPECIFIC COLORIZING */

		output = subColorizeCSS( output ); 
		
		break;
		
		default: 
			// nothing
		}
	
	theElement.innerHTML = output;

}
		
// cookie setter 
function setCookie(name, value, expires) {
	// we'll default to a year from current date in the event expires is not passed
	var expdate = new Date (); // pre-set to the current time and date
	expdate.setTime(expdate.getTime() + 1000 * 60 * 60 * 24 * 365); // add one year to it 
	
	expires = (expires == null) ? expdate : expires; 
	document.cookie = name + "=" + escape(value) + "; expires=" + expires.toGMTString() + "; path=/";
}


/* detail frame specific */
function viewFormCode( which, windowname ) {
	windowname = (windowname == null) ? 'self' : windowname;
	// openWindow('about:blank','codeView');
	top.frames['detail'].frames[windowname].document.getElementById(which).target = 'codeView';
	top.frames['detail'].frames[windowname].document.getElementById(which).submit();
}

function copyToClipboard( which, windowname ) {
	windowname = (windowname == null) ? 'self' : windowname;
	tempcopy = top.frames['detail'].frames[windowname].document.getElementById(which);
	tempcopy.focus(); tempcopy.select();
	copythis = tempcopy.createTextRange()
	copythis.execCommand("Copy")
}

function toggleDivs( which, windowname, maxnum ) { 
	windowname = (windowname == null) ? 'self' : windowname;
	maxnum = (maxnum == null) ? 9 : maxnum;
	// divs:  sourceX
	theDiv = top.frames['detail'].frames[windowname].document.getElementById('source' + which);
	// btns: sourcebtnX
	theBtn = top.frames['detail'].frames[windowname].document.getElementById('sourcebtn' + which);
	for (i = 1; i <= maxnum; i++ ) {
		theOtherDiv = top.frames['detail'].frames[windowname].document.getElementById('source' + i);
		theOtherBtn = top.frames['detail'].frames[windowname].document.getElementById('sourcebtn' + i);
		if( theOtherDiv ) {
			theOtherDiv.className = 'sourceoff'; // theOtherDiv.style.display = 'none';
		}
		if( theOtherBtn ) {
			theOtherBtn.className = 'navlt';
		}
	}
	theDiv.className = 'sourceon'; // theDiv.style.display = 'block';
	theBtn.className = 'navltdown';
}

/* ----------------------- */

function showGenericDiv( dn, windowname ) {
	windowname = (windowname == null) ? 'self' : windowname; 
	if (IE4 || NS6) {
		if (top.frames['detail'].frames[windowname].document.getElementById(dn)) {
			thisdiv = top.frames['detail'].frames[windowname].document.getElementById(dn);
		    thisdiv.style.visibility = 'visible';
		}
	}
}

function hideGenericDiv(dn, windowname) {
	windowname = (windowname == null) ? 'self' : windowname;
	if(dn) {
			if (IE4 || NS6) { 
				thisdiv = top.frames['detail'].frames[windowname].document.getElementById(dn);
				thisdiv.style.visibility = 'hidden'; }
		}
}

// opens a fixed window, no scrolling or resize, centered
function openPopup( url, name, height, width ){
		height = (height == null) ? 600 : height;
		width = (width == null) ? 800 : width;
		displayHeight=screen.height; 
		displayWidth=screen.width;
		centeredHeight = (displayHeight-height) / 2; 
		centeredWidth = (displayWidth-width) / 2;
		window[name] = window.open(url, name, 'width=' + width + ',height=' + height + ',toolbar=0,location=0,status=0,menubar=0,scrollbars=0,resizable=1,left=' + centeredWidth + ',top=' + centeredHeight + ',screenX=' + centeredWidth + ',screenY=' + centeredHeight);
}

// opens a resizable, scrollable window, centered 
function openWindow( url, name, height, width ){ 
		height = (height == null) ? 600 : height;
		width = (width == null) ? 800 : width;
		displayHeight=screen.height; 
		displayWidth=screen.width;
		centeredHeight = (displayHeight-height) / 2; 
		centeredWidth = (displayWidth-width) / 2;
		window[name] = window.open(url, name, 'width=' + width + ',height=' + height + ',toolbar=0,location=0,status=0,menubar=0,scrollbars=1,resizable=1,left=' + centeredWidth + ',top=' + centeredHeight + ',screenX=' + centeredWidth + ',screenY=' + centeredHeight);
} 